Package: ccfindR
Version: 1.31.0
Date: 2019-10-1
Title: Cancer Clone Finder
Authors@R: c(person('Jun','Woo',role=c('aut','cre'),email='jwoo@umn.edu'),
             person('Jinhua','Wang',role='aut',email='wangjh@umn.edu'))
Depends: R (>= 3.6.0)
Imports: stats, S4Vectors, utils, methods, Matrix,
        SummarizedExperiment, SingleCellExperiment, Rtsne, graphics,
        grDevices, gtools, RColorBrewer, ape, Rmpi, irlba, Rcpp, Rdpack
        (>= 0.7)
RdMacros: Rdpack
biocViews: Transcriptomics, SingleCell, ImmunoOncology, Bayesian,
        Clustering
Description: A collection of tools for cancer genomic data clustering
    analyses, including those for single cell RNA-seq.
    Cell clustering and feature gene selection analysis employ Bayesian 
    (and maximum likelihood) non-negative matrix factorization (NMF) algorithm. 
    Input data set consists of RNA count matrix, gene, and cell bar code 
    annotations.  Analysis outputs are factor matrices for multiple ranks and
    marginal likelihood values for each rank. The package includes utilities for 
    downstream analyses, including meta-gene identification, visualization, and 
    construction of rank-based trees for clusters.
License: GPL (>= 2)
NeedsCompilation: yes
URL: http://dx.doi.org/10.26508/lsa.201900443
RoxygenNote: 6.1.1
Encoding: UTF-8
Suggests: BiocStyle, knitr, rmarkdown
VignetteBuilder: knitr
LinkingTo: Rcpp, RcppEigen
Author: Jun Woo [aut, cre],
  Jinhua Wang [aut]
Maintainer: Jun Woo <jwoo@umn.edu>
git_url: https://git.bioconductor.org/packages/ccfindR
git_branch: devel
git_last_commit: ee2b32c
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-11-03
Packaged: 2025-11-03 21:40:07 UTC; biocbuild

#' Cell type assignment via GSEA
#'
#' Computes GSEA enrichment score of marker sets in meta gene list
#' 
#' If \code{obj} is of clas \code{scNMFSet}, it computes meta gene list using
#' \code{\link{meta_gene.cv}}. Otherwise, \code{obj} is expected to be 
#' a data frame of the same structure as the output of \code{meta_gene.cv};
#' the number of rows same as the total number of metagenes per cluster, 
#' three columns per each cluster (gene name, meta-gene score, and coefficient of variation).
#' The argument \code{gset} is a list of gene sets to be checked for enrichment in 
#' each cluster meta gene list. The enrichment score is computed using 
#' the GSEA algorithm \insertCite{subramanian_etal}{ccfindR}.
#'
#' @param obj Object of class \code{scNMFSet}.
#' @param rank Rank to examine
#' @param gset List of gene sets to be used as markers
#' @param gene_names Names of genes to be used for meta-gene identification
#' @param p Enrichment score exponent.
#' @param remove.na Remove gene sets with no overlap
#' @param p.value Estimatte p values using permutation
#' @param nperm No. of permutation replicates
#' @param progress.bar Display progress bar for p value computation
#' @param grp.prefix Gene name prefix to search for with wildcard matches in query
#' @return Matrix of enrichment score statistics with cell types in rows and
#'         clusters in columns
#' @references
#' \insertRef{subramanian_etal}{ccfindR}
#' @examples
#' dir <- system.file('extdata',package='ccfindR')
#' pbmc <- read_10x(dir)
#' pbmc <- vb_factorize(pbmc, ranks=5)
#' meta <- meta_gene.cv(pbmc,rank=5, gene_names=rowData(pbmc)[,2])
#' markers <- list('B cell'=c('CD74','IG','HLA'),
#'                 'CD8+ T'=c('CD8A','CD8B','GZMK','CCR7','LTB'),
#'                 'CD4+ T'=c('CD3D','CD3E','IL7R','LEF1'),
#'                 'NK'=c('GNLY','NKG7','GZMA','GZMH'),
#'                 'Macrophage'=c('S100A8','S100A9','CD14','LYZ','CFD'))
#' gsea <- assignCelltype(meta, rank=5, gset=markers, grp.prefix=c('IG','HLA'))
#' gsea
#' @export
assignCelltype <- function(obj, rank, gset, gene_names=NULL, p=0, remove.na=FALSE,
                 p.value=FALSE, nperm=1000, progress.bar=TRUE,
                 grp.prefix=c('IG')){
  
  if(is(obj, 'scNMFSet'))
    meta <- meta_gene.cv(object=obj, rank=rank, max.per.cluster=Inf,
                       gene_names=gene_names, subtract.mean=TRUE,
                       log=TRUE, cv.max=Inf)
  else if(is(obj, 'data.frame')){
    meta <- obj
    if(NCOL(meta)!=rank*3) stop('Incorrect dimension of meta')
  } else stop('Incorrect input type of obj')
    
  glist <- meta[,seq(1,3*rank,by=3)]
  gwgt <- meta[,seq(2,3*rank+1,by=3)]
  
  ES <- gsea(glist=glist, gwgt=gwgt, gset=gset, p=p, remove.na=remove.na,
             grp.prefix=grp.prefix)
  
  if(!p.value) return(ES)
  N <- NROW(glist)
  nS <- length(gset)
  Ep <- matrix(0, nrow=NROW(ES), ncol=rank)
  if(progress.bar) pb <- utils::txtProgressBar(style=3)
  for(k in seq_len(nperm)){
    perm <- sample(N)
    x <- gsea(glist=glist[perm,], gwgt=gwgt[perm,], gset=gset, p=p, 
              remove.na=remove.na, grp.prefix=grp.prefix)
    Ep <- Ep + (ES < x)
    if(progress.bar & k %% 10==0)
      utils::setTxtProgressBar(pb, value=k/nperm)
  }
  if(progress.bar) close(pb)
  Ep <- Ep / nperm
  
  return(list(ES=ES, pvalue=Ep))
}

gsea <- function(glist, gwgt, gset, p, remove.na, grp.prefix=c('IG','KRT')){
  
  rank <- NCOL(glist)
  nS <- length(gset)
  N <- NROW(glist)
  
  ES <- matrix(0, nrow=nS, ncol=rank)
  colnames(ES) <- seq_len(rank)
  rownames(ES) <- names(gset)
  for(k in seq_len(rank)){
    for(is in seq_len(nS)){
      gs <- gset[[is]]
      gl <- glist[,k]
      flag <- !is.na(gwgt[,k])
      gl <- gl[flag]
      gw <- gwgt[flag,k]
      x <- overlap(query=gl, glist=gs, grp.prefix=grp.prefix)
      if(sum(x)==0){
        ES[is,k] <- NA
        next()
      }
      ph <- gw^p
      ph <- cumsum(x * ph)
      phit <- ph / ph[length(ph)]
      
      y <- ! (gl %in% gs)
      pm <- cumsum(y)
      pmiss <- pm / pm[length(pm)]

      ES[is,k] <- max(phit-pmiss)
    }
  }
  
  if(remove.na) ES <- ES[!is.na(ES[,1]),]
  
  return(ES)
}

overlap <- function(query, glist, grp.prefix=c('IG')){
  
  glist0 <- glist[!glist %in% grp.prefix] # non-IG genes
  x <- query %in% glist0
  grp <- grp.prefix[grp.prefix %in% glist]
  for(i in seq_along(grp)){
    gr <- grp[i]
    x1 <- substr(query, start=1, stop=nchar(gr)) %in% gr
    x <- x | x1
  }
  return(x)
}

## ----eval=FALSE---------------------------------------------------------------
# BiocManager::install('ccfindR')

## -----------------------------------------------------------------------------
library(ccfindR)

## ----echo=T-------------------------------------------------------------------
# A toy matrix for count data
set.seed(1)
mat <- matrix(rpois(n = 80, lambda = 2), nrow = 4, ncol = 20)
ABC <- LETTERS[1:4]
abc <- letters[1:20]
rownames(mat) <- ABC
colnames(mat) <- abc

## ----echo=T-------------------------------------------------------------------
# create scNMFSet object
sc <- scNMFSet(count = mat)

## ----echo=T-------------------------------------------------------------------
# create scNMFSet object
sc <- scNMFSet(assays = list(counts = mat))

## -----------------------------------------------------------------------------
# set row and column names
suppressMessages(library(S4Vectors))
genes <- DataFrame(ABC)
rownames(genes) <- ABC
cells <- DataFrame(abc)
rownames(cells) <- abc
sc <- scNMFSet(count = mat, rowData = genes, colData = cells)
sc

## -----------------------------------------------------------------------------
# read sparse matrix
dir <- system.file('extdata', package = 'ccfindR')
mat <- Matrix::readMM(paste0(dir,'/matrix.mtx'))
rownames(mat) <- 1:nrow(mat)
colnames(mat) <- 1:ncol(mat)
sc <- scNMFSet(count = mat, rowData = DataFrame(1:nrow(mat)),
               colData = DataFrame(1:ncol(mat)))
sc

## -----------------------------------------------------------------------------
# read 10x files
sc <- read_10x(dir = dir, count = 'matrix.mtx', genes = 'genes.tsv',
               barcodes = 'barcodes.tsv')
sc

## -----------------------------------------------------------------------------
# slots and subsetting
counts(sc)[1:7,1:3]
head(rowData(sc))
head(colData(sc))
sc2 <- sc[1:20,1:70]       # subsetting of object
sc2 <- remove_zeros(sc2)   # remove empty rows/columns
sc2

## ----cells, cache=T, fig.small=TRUE,fig.cap="Quality control filtering of cells. Histogram of UMI counts is shown. Cells can be selected (red) by setting lower and upper thresholds of the UMI count."----
sc <- filter_cells(sc, umi.min = 10^2.6, umi.max = 10^3.4)

## ----genes, cache=T, fig.small=TRUE, fig.cap="Selection of genes for clustering. The scatter plot shows distributions of expression variance to mean ratio (VMR) and the number of cells expressed. Minimum VMR and a range of cell number can be set to select genes (red). Symbols in orange are marker genes provided as input, selected irrespective of expression variance."----
markers <- c('CD4','CD8A','CD8B','CD19','CD3G','CD3D',
             'CD3Z','CD14')
sc0 <- filter_genes(sc, markers = markers, vmr.min = 1.5, 
            min.cells.expressed = 50, rescue.genes = FALSE)

## ----rescue, cache=T, echo=T, fig.small=TRUE, fig.cap='Additional selection of genes with modes at nonzero counts. Symbols in blue represent genes rescued.'----
sc_rescue <- filter_genes(sc, markers = markers, vmr.min = 1.5, min.cells.expressed = 50,
                          rescue.genes = TRUE, progress.bar = FALSE)

## ----cache=T------------------------------------------------------------------
rownames(sc_rescue) <- rowData(sc_rescue)[,2]
sc <- sc_rescue

## ----cache=T------------------------------------------------------------------
set.seed(1)
sc <- factorize(sc, ranks = 3, nrun = 1, ncnn.step = 1, 
                criterion='connectivity', verbose = 3)

## ----cache=T------------------------------------------------------------------
sc <- factorize(sc, ranks = 3, nrun = 5, verbose = 2)

## ----cache=T------------------------------------------------------------------
sc <- factorize(sc, ranks = seq(3,7), nrun = 5, verbose = 1, progress.bar = FALSE)

## -----------------------------------------------------------------------------
measure(sc)

## ----measure, fig.large=TRUE, fig.cap='Factorization quality measures as functions of the rank. Dispersion measures the degree of bimodality in consistency matrix. Cophenetic correlation measures the degree of agreement between consistency matrix and hierarchical clustering.'----
plot(sc)

## ----cache=T------------------------------------------------------------------
sb <- sc_rescue
set.seed(2)
sb <- vb_factorize(sb, ranks =3, verbose = 3, Tol = 2e-4, hyper.update.n0 = 5)

## ----cache=T------------------------------------------------------------------
sb <- vb_factorize(sb, ranks = seq(2,7), nrun = 5, verbose = 1, Tol = 1e-4, progress.bar = FALSE)

## -----------------------------------------------------------------------------
measure(sb)

## ----lml, fig.small=TRUE, fig.cap='Dependence of log ML with rank.'-----------
plot(sb)

## -----------------------------------------------------------------------------
optimal_rank(sb)

## -----------------------------------------------------------------------------
ranks(sb)

head(basis(sb)[ranks(sb)==5][[1]]) # basis matrix W for rank 5

## ----sb, cache=T, fig.small=TRUE, fig.cap='Heatmap of basis matrix elements. Marker genes selected in rows, other than those provided as input, are based on the degree to which each features strongly in a particular cluster only and not in the rest. Columns represent the clusters.'----
feature_map(sb, markers = markers, rank = 5, max.per.cluster = 4, gene.name = rowData(sb)[,2],
         cexRow = 0.7)

## -----------------------------------------------------------------------------
cell_type <- c('B_cell','CD8+_T','CD4+_T','Monocytes','NK')
colnames(basis(sb)[ranks(sb) == 5][[1]]) <- cell_type
rownames(coeff(sb)[ranks(sb) == 5][[1]]) <- cell_type

## ----sc, fig.small=TRUE, fig.cap = 'Heatmap of cluster coefficient matrix elements. Rows indicate clusters and columns the cells.'----
cell_map(sb, rank = 5)

## ----tsne, fig.cap='tSNE-based visualization of clustering. Coefficient matrix elements of cells were used as input with colors indicating predicted cluster assignment. The bar plot shows the cell counts of each cluster.'----
visualize_clusters(sb, rank = 5, cex = 0.7)

## ----tree, fig.small=TRUE, fig.cap = "Hierarchical tree of clusters derived from varying ranks. The rank increases from 2 to 5 horizontally and nodes are labeled by cluster IDs which bifurcated in each rank."----
tree <- build_tree(sb, rmax = 5)
tree <- rename_tips(tree, rank = 5, tip.labels = cell_type)
plot_tree(tree, cex = 0.8, show.node.label = TRUE)

#' Generate Newick format tree string from tree list object 
#' 
#' @param tree Tree list object from \code{\link{build_tree}}
#' @param parent Parent ID 
#' @param string Newick string of parent tree
#' @return String of newick tree
#' @examples
#' set.seed(1)
#' x <- simulate_whx(nrow=50,ncol=100,rank=5)
#' s <- scNMFSet(x$x)
#' s <- vb_factorize(s,ranks=seq(2,8),nrun=5)
#' tree <- build_tree(s,rmax=5)
#' nw <- newick(tree=tree)
#' nw
#' @export
newick <- function(tree, parent='1.1',string=''){
  
  if(string=='') root=TRUE
  else root=FALSE
  string <- paste0(string,'(')
  for(i in seq_len(length(tree))){
    if(length(tree[[i]])==1){
      bl <- as.numeric(strsplit(tree[[i]],split='[.]')[[1]][1]) -
        as.numeric(strsplit(parent,split='[.]')[[1]][1])
      string <- paste0(string,tree[[i]],':',toString(bl))
    }
    else{
      sub <- newick(tree[[i]], parent=names(tree)[i], string)
      bl <- as.numeric(strsplit(names(tree)[i],split='[.]')[[1]][1]) -
        as.numeric(strsplit(parent,split='[.]')[[1]][1])
      string <- paste0(sub, names(tree)[i],':',toString(bl))
    }
    if(i < length(tree)) string <- paste0(string,',')
    else string <-paste0(string,')')
  }
  if(root) string <- paste0(string,';')
  return(string)
}

# Recursive function for branching a tree
branch.tree <- function(tree, parent.id, progenies){
  for(i in seq_len(length(tree))){
    if(length(tree[[i]])==1){
      if(tree[[i]] == parent.id){
        tree[[i]] <- progenies
        names(tree)[i] <- parent.id
        return(tree)
      }
    } else{
      tree[[i]] <- branch.tree(tree[[i]], parent.id, progenies)
    }
  }
  return(tree)
}

update.tree <- function(tree, parent.id, progenies){
  for(i in seq_len(length(tree))){
    if(length(tree[[i]])==1){
      if(tree[[i]] %in% parent.id)
       tree[[i]] <- progenies[tree[[i]]==parent.id]
    } else
       tree[[i]] <- update.tree(tree[[i]], parent.id, progenies)
  }
  return(tree)
}

#' Build tree connecting clusters at different ranks
#' 
#' @param object Object of class \code{scNMFSet}
#' @param rmax Maximum rank at which tree branching stops
#' @return List containing the tree structure
#' @examples
#' set.seed(1)
#' x <- simulate_whx(nrow=50,ncol=100,rank=5)
#' s <- scNMFSet(x$x)
#' s <- vb_factorize(s,ranks=seq(2,8),nrun=5)
#' tree <- build_tree(s,rmax=5)
#' tree
#' @export
build_tree <- function(object, rmax){
  
  r0 <- 3
  if(missing(rmax)) rmax <- ranks(object)[length(ranks(object))]
  id <- seq(which(ranks(object) == r0-1),
            which(ranks(object) == rmax))
  cluster <- NULL
  for(i in id){
    h <- coeff(object)[[i]]
    cid <- apply(h,2,which.max)
    cluster <- cbind(cluster,cid)
    colnames(cluster)[ncol(cluster)] <- paste0('r', ranks(object)[i])
  }
  
  rse <- seq(r0,rmax,1)
  y <- vector('list',length(rse))
  tree <- list('2.1','2.2') # initial split for rank 2
  names(y) <- rse
  for(n in rse){
    rank0 <- paste0('r',toString(n-1))
    rank1 <- paste0('r',toString(n))
    x0 <- cluster[, rank0]
    x1 <- cluster[, rank1]
#   x <- table(x0,x1)
    x <- table(factor(x0, levels=seq_len(n-1)),
               factor(x1, levels=seq_len(n)))
    z <- apply(x, 2, which.max)
    z <- vapply(z, function(x){if(length(x)>1) x[1] else x}, integer(1))
        # break ties
    names(z) <- seq_len(n)
    y[[toString(n)]] <- z
    
    w <- names(table(z))[table(z) > 1]  # parent id that splitted
    p <- mapply(function(x){names(z)[z==x]},w, SIMPLIFY=FALSE)
    
    for(i in seq_len(length(w))){
      np <- paste(n,p[[i]],sep='.')
      split <- as.list(np)
      tree <- branch.tree(tree, paste(n-1,w[i],sep='.'), split)
    }
    
    w0 <- names(table(z))[table(z)==1]
    p0 <- names(z)[match(w0,z)]
    rename <- paste(n,p0,sep='.')
    tree <- update.tree(tree, paste(n-1,w0,sep='.'), rename)
  }
  return(tree)
}

#' Rename tips of trees with cell types
#' 
#' @param tree List containing tree
#' @param tip.labels Vector of new names for tips
#' @param rank Rank value of which tip names are to be replaced
#' @return List containing tree with updated tip labels 
#' @examples
#' set.seed(1)
#' x <- simulate_whx(nrow=50,ncol=100,rank=5)
#' s <- scNMFSet(x$x)
#' s <- vb_factorize(s,ranks=seq(2,8),nrun=5)
#' tree <- build_tree(s,rmax=5)
#' tree <- rename_tips(tree,rank=5,tip.labels=letters[seq_len(5)])
#' tree 
#' @export
rename_tips <- function(tree, rank, tip.labels){
  
  for(i in seq_len(length(tree))){
    if(length(tree[[i]])==1){  # a tip
      x <- strsplit(tree[[i]], split='[.]')[[1]]
      if(as.numeric(x[1])==rank){
        cid <- as.numeric(x[2])
        tree[[i]] <- paste(toString(rank),tip.labels[cid],sep='.')
      }
    }else tree[[i]] <- rename_tips(tree[[i]], rank, tip.labels)
  }
  return(tree)
}

#' Plot cluster tree
#' 
#' Visualize the output of \code{\link{build_tree}} as a dendrogram.
#' 
#' Uses \code{\link[ape]{plot.phylo}} to visualize cluster tree.
#' 
#' @param tree List containing tree structure. Output from 
#'   \code{\link{build_tree}}
#' @param direction \code{c('rightwards','downwards')}; 
#'   the direction of dendrogram
#' @param cex Font size of edge/tip labels
#' @param ... Other parameters to \code{\link{plot.phylo}}
#' @return \code{NULL}
#' @examples
#' set.seed(1)
#' x <- simulate_whx(nrow=50,ncol=100,rank=5)
#' s <- scNMFSet(x$x)
#' s <- vb_factorize(s,ranks=seq(2,8),nrun=5)
#' tree <- build_tree(s,rmax=5)
#' plot_tree(tree)
#' @export
plot_tree <- function(tree, direction='rightwards', cex = 0.7, ...){
  
  nwk <- newick(tree)
  phylo <- ape::read.tree(text=nwk)
  plot(x=phylo, direction=direction, cex=cex, ...)
     
  return(invisible(tree))
}

#' Read 10x data and generate scNMF object
#' 
#' Read count, gene, and barcode annotation data in 10x format 
#' and create an object of class \code{scNMFSet}.
#' 
#' Files for \code{count}, \code{genes}, and \code{barcodes} are
#' assumed to be present in \code{dir}. 
#' Count data are in sparse "Matrix Market" format 
#' (\url{https://math.nist.gov/MatrixMarket/formats.html}).
#' 
#' @param dir Name of directory containing data files.
#' @param count Name of count matrix file.
#' @param genes Name of gene annotation file.
#' @param barcodes Name of cell annotation file.
#' @param remove.zeros If \code{TRUE}, empty rows/columns are 
#'        removed.
#' @examples
#' library(S4Vectors)
#' s <- scNMFSet(count=matrix(rpois(n=12,lambda=3),4,3))
#' rowData(s) <- DataFrame(seq_len(4))
#' colData(s) <- DataFrame(seq_len(3))
#' write_10x(s,dir='.')
#' s <- read_10x(dir='.')
#' s
#' @return Object of class \code{scNMFSet}
#' @export
#' @import SingleCellExperiment
read_10x <- function(dir, count='matrix.mtx', genes='genes.tsv',
                     barcodes='barcodes.tsv', remove.zeros=TRUE){
  
  if(!dir.exists(dir)) stop(cat('Input directory',dir,'does not exist\n'))
  count <- paste0(dir, '/', count)
  if(!file.exists(count)) stop(cat('Count file',count,'does not exist\n'))
  Mat <- as(Matrix::readMM(count),'dgCMatrix')
  genes <- paste0(dir, '/', genes)
  if(!file.exists(genes)) 
    stop(cat('Count file',genes,'does not exist\n'))
  glist <- utils::read.table(genes,stringsAsFactors=FALSE)
  barcodes <- paste0(dir,'/', barcodes)
  if(!file.exists(barcodes)) 
    stop(cat('Count file',barcodes,'does not exist\n'))
  clist <- utils::read.table(barcodes,stringsAsFactors=FALSE)
  rownames(Mat) <- rownames(glist) <- glist[,1]
  colnames(Mat) <- rownames(clist) <- clist[,1]
  
  x <- scNMFSet(assays=list(counts=Mat), remove.zeros=FALSE)
  rowData(x) <- as(glist, 'DataFrame')
  rownames(x) <- rownames(glist)
  clist <- as(clist, 'DataFrame')
  colData(x) <- clist
  colnames(x) <- rownames(clist)
  if(remove.zeros) x <- remove_zeros(x)
  return(x)
}

#' Filter cells with quality control criteria
#' 
#' Remove low quality cell entries from object
#' 
#' Takes as input \code{scNMFSet} object and plots histogram of UMI 
#' counts for each 
#' cell. Optionally, cells are filtered using minimum and maximum UMI counts. 
#' The resulting object is returned after removing empty rows and columns, 
#' if any.
#' 
#' @param object \code{scNMFSet} object
#' @param umi.min Minimum UMI count for cell filtering
#' @param umi.max Maximum UMI count for cell filtering
#' @param plot If \code{TRUE}, the UMI count distribution of all cells 
#'   will be displayed. Cells selected are colored red.
#' @param remove.zeros Remove rows/columns containing zeros only
#' @return \code{scNMFSet} object with cells filtered.
#' @examples
#' set.seed(1)
#' s <- scNMFSet(matrix(stats::rpois(n=1200,lambda=3),40,30))
#' s <- filter_cells(s,umi.min=10^2.0,umi.max=10^2.1)
#' @export
filter_cells <- function(object, umi.min=0, umi.max=Inf, plot=TRUE, 
                         remove.zeros=TRUE){
  
  umi.count <- Matrix::colSums(counts(object))
  selected_cells <- umi.min <= umi.count & umi.count <= umi.max
  
  h <- graphics::hist(log10(umi.count), plot=FALSE)
  n <- length(h$counts)
  color <- rep('white',n)
  if(umi.min | umi.max<Inf)
    color[log10(umi.min) <= h$mids & h$mids <= log10(umi.max)] <- 'red'
  if(plot) plot(h, col=color, main='Cells')
  if(umi.min | umi.max<Inf)
    cat(sum(selected_cells),'cells out of',dim(object)[2],'selected\n')
  
  object <- object[, selected_cells]
  return(remove_zeros(object))
}

#' Filter genes with quality control criteria
#' 
#' Select genes with high relative variance in count data for 
#' further analysis
#' 
#' Takes as input \code{scNMFSet} object and scatterplot no. of cells 
#' expressed versus VMR (variance-to-mean ratio)
#' for each gene. Optionally, genes are filtered using minimum VMR 
#' together with a range of no. of cells expressed.
#'
#' @param object \code{scNMFSet} object.
#' @param markers A vector containing marker genes to be selected. 
#'    All rows in 
#' \code{rowData} that contain columns matching this set will 
#'    be selected. 
#' @param vmr.min Minimum variance-to-mean ratio for gene filtering.
#' @param min.cells.expressed Minimum no. of cells expressed for gene 
#'    filtering.
#' @param max.cells.expressed Maximum no. of cells expressed for gene 
#'    filtering.
#' @param rescue.genes Selected additional genes whose (non-zero)
#'        count distributions have at least one mode. 
#' @param plot Plot the distribution of no. of cells expressed vs. VMR.        
#' @param log Axis in log-scale, \code{c('x','y','xy')}.
#' @param progress.bar Display progress of mode-gene scan or VMR
#'    calculation with \code{save.memory = TRUE}.
#' @param save.memory For a very large number of cells, calculate VMR 
#'    row by row while avoiding calls to \code{as.matrix()}.
#'    Progress bar will be displayed unless \code{progress.bar=FALSE}.
#' @param cex Symbol size for each gene in the plot. 
#' @return Object of class \code{scNMFSet}.
#' @examples
#' set.seed(1)
#' s <- scNMFSet(matrix(stats::rpois(n=1200,lambda=3),40,30))
#' s <- filter_genes(s,vmr.min=1.0,min.cells.expressed=28,
#'         rescue.genes=FALSE)
#' @export
filter_genes <- function(object, markers= NULL, vmr.min=0, 
                         min.cells.expressed=0, max.cells.expressed=Inf, 
                         rescue.genes=FALSE, progress.bar=TRUE,
                         save.memory=FALSE, plot=TRUE, log='xy',cex=0.5){

  ncexpr <- Matrix::rowSums(counts(object) > 0) 
  # no. of cells expressing each gene
  count <- counts(object)
  count <- count[ncexpr>0,]
  ncexpr <- ncexpr[ncexpr>0]
  ngenes <- nrow(count)
  
  selected_genes <- variable_genes <- rep(FALSE, ngenes)
  
  if(is.null(markers)) marker_genes=NULL
  else{
    for(k in seq_len(ncol(rowData(object))))
      selected_genes <- selected_genes | 
        (mk <- rowData(object)[,k] %in% markers)
    marker_genes <- selected_genes
  } 
    
  vmr <- calc_vmr(count, save.memory=save.memory, 
                  progress.bar=progress.bar)
  
  variable_genes <- vmr.min < vmr & 
            min.cells.expressed <= ncexpr & 
            ncexpr <= max.cells.expressed
  if(rescue.genes & sum(variable_genes) < ngenes){
    mode_genes <- c()
    cat('Looking for genes with modes ...\n')
    if(progress.bar) pb <- utils::txtProgressBar(style=3)
    for(i in seq_len(ngenes)){
      if(variable_genes[i]) mode <- FALSE
      else mode <- has_mode(counts(object)[i,])
      mode_genes <- c(mode_genes,mode)
      if(progress.bar) utils::setTxtProgressBar(pb,i/ngenes)
    }
    if(progress.bar) close(pb)
    selected_genes <- selected_genes | variable_genes | mode_genes
  }
  else{ 
    selected_genes <- selected_genes | variable_genes
    mode_genes <- NULL
  }
  
  if(!is.null(markers)) if(sum(marker_genes) > 0)
    cat(sum(marker_genes),'marker genes found\n')
  if(vmr.min>0 | min.cells.expressed>0 | max.cells.expressed <Inf){
    cat(sum(variable_genes),'variable genes out of',dim(object)[1],'\n')
    if(rescue.genes) cat(sum(selected_genes & ! variable_genes),
                         'additional genes rescued\n')
    cat(sum(selected_genes),'genes selected\n')
  }
  
  if(plot) plot_genes(object, vmr=vmr, ncexpr=ncexpr, 
    selected_genes=selected_genes, variable_genes=variable_genes,
    mode_genes=mode_genes, marker_genes=marker_genes, log=log,cex=cex) 
  
  return(object[selected_genes,])
}

# Calculate variance-to-mean ratio
calc_vmr <- function(count, save.memory=FALSE, progress.bar=TRUE){
  
  gmean <- Matrix::rowMeans(count)
  ngenes <- nrow(count)
  if(!save.memory) 
    var <- rowVars(count,means=gmean) # memory intensive
  else{
    if(progress.bar){
      cat('Calculating vmr...\n')
      pb <- utils::txtProgressBar(style=3)
    }
    var <- c()
    denom <- ncol(count)  
    for(i in seq_len(nrow(count))){
      g <- count[i,]-gmean[i]
      var <- c(var, sum(g*g)/denom)
      if(progress.bar) utils::setTxtProgressBar(pb, i/ngenes)
    }
    if(progress.bar) close(pb)
  }
  return(var/gmean)
}

#' Plot gene variance distributions
#' 
#' Gene variance to mean ratio and the number of expressing cells are
#' plotted.
#' 
#' This function can be called separately or is also called within
#' \code{\link{filter_genes}} by default. 
#' In the latter case, parameters other
#' than \code{object} will have been already filled. If called separately
#' with \code{NULL} gene lists, VMR is recalculated but gene selection
#' is not done.
#' 
#' @param object Object containing count data
#' @param vmr Variance to mean ratio (VMR)
#' @param ncexpr Number of cells expressing each gene
#' @param selected_genes Logical vector specifing genes selected
#' @param variable_genes Logical vector specifing genes with high VMR
#' @param mode_genes Logical vector specifying genes with nonzero modes
#' @param marker_genes Logical vector specifying marker genes
#' @param save.memory If \code{TRUE}, calculate VMR using slower
#'        method to save memory. Not used when gene lists are supplied.
#' @param progress.bar Display progress bar for VMR calculation.
#'        Not used when gene lists are supplied.
#' @param cex Symbol size for genes (supplied to \code{plot()}).
#' @param log Axis in log-scale, \code{c('x','y','xy')}.
#' @return \code{NULL}
#' @examples
#' set.seed(1)
#' s <- scNMFSet(matrix(stats::rpois(n=1200,lambda=3),40,30))
#' plot_genes(s)
#' @export
plot_genes <- function(object, vmr=NULL, ncexpr=NULL, selected_genes=NULL, 
                  variable_genes=NULL, mode_genes=NULL, 
                  marker_genes=NULL, save.memory=FALSE, progress.bar=TRUE, 
                  log='xy', cex=0.5){
  
  if(is.null(ncexpr) | is.null(vmr)){  # no. of cells expressing each gene
    ncexpr <- Matrix::rowSums(counts(object) > 0) 
    count <- counts(object)
    count <- count[ncexpr>0,]
    ncexpr <- ncexpr[ncexpr>0]
  }
  if(is.null(vmr))
    vmr <- calc_vmr(count, save.memory=save.memory, progress.bar=progress.bar)
  
  ncexpr <- ncexpr[vmr>0]
  vmr <- vmr[vmr>0]
  ngenes <- length(vmr)
  if(is.null(selected_genes)) selected_genes <- rep(FALSE, ngenes)
  
  xlim=c(min(ncexpr),max(ncexpr))
  if(sum(selected_genes) < ngenes | !is.null(variable_genes)){
    graphics::plot(x=ncexpr[!selected_genes], y=vmr[!selected_genes], 
         xlim=xlim,ylim=c(min(vmr),max(vmr)), log=log, pch=21, 
        col='gray', bg='white', xlab='No. of cells expressed', ylab='VMR', 
        main='Genes', cex=cex, bty='n')
    if(!is.null(variable_genes))
      graphics::points(x=ncexpr[variable_genes], y=vmr[variable_genes], 
                       pch=21, bg='red', cex=cex, lwd=0.5)
    if(!is.null(mode_genes))
        graphics::points(x=ncexpr[mode_genes], y=vmr[mode_genes], 
              pch=21, bg='blue', cex=cex, lwd=0.5)
    if(!is.null(marker_genes))
      if(sum(marker_genes) > 0)
        points(x=ncexpr[marker_genes], y=vmr[marker_genes], pch=21, 
                 bg='orange', cex=cex, lwd=0.5)
  }else{
    graphics::plot(x=ncexpr[variable_genes], y=vmr[variable_genes], 
        xlim=xlim,ylim=c(min(vmr),max(vmr)), pch=21, bg='white', 
        cex=cex, lwd=0.5, log=log, col='gray', xlab='No. of cells expressed', 
        ylab='VMR', main='Genes', bty='n')
    if(!is.null(marker_genes)) if(sum(marker_genes) > 0)
        graphics::points(x=ncexpr[marker_genes], y=vmr[marker_genes], pch=21, 
               bg='orange', cex=cex, lwd=0.5)
  }
  return(invisible(object))
}

#' Normalize count data
#' 
#' Rescale count matrix entries such that all cells have the same library size.
#' 
#' For analysis purposes, it is sometimes useful to rescale integer count
#' data into floats such that all cells have the same median counts. 
#' This function will calculate the median of all UMI counts of cells (total
#' number of RNAs derived from each cell). All count data are then rescaled
#' such that cells have uniform UMI count equal to the median. 
#' 
#' @param object \code{scNMFSet} object.
#' @return \code{scNMFSet} object with normalized count data.
#' @examples
#' library(Matrix)
#' set.seed(1)
#' s <- scNMFSet(count=matrix(rpois(n=1200,lambda=3),40,30))
#' colMeans(counts(s))
#' s <- normalize_count(s)
#' colMeans(counts(s))
#' @export
normalize_count <- function(object){
  
  count <- counts(object)
  umi.count <- Matrix::colSums(count)
  count <- t(t(count)/umi.count)
  med <- stats::median(umi.count)
  count <- count*med
  counts(object) <- count
  object
}

has_mode <- function(g){
  
  tb <- table(g)
  flag <- FALSE
  tb <- tb[names(tb)]    # remove zero count
  n <- length(tb)
  if(n<2) return(FALSE)
  for(k in seq_len(n-1)) if(tb[k] < tb[k+1]) return(TRUE)
  return(FALSE)

}

rowVars <- function(x, means){
  if(missing(means)) means <- Matrix::rowMeans(x)
  Matrix::rowSums((x-means)^2)/(dim(x)[2]-1)
}

#' Plot heatmap of metagene matrix
#' 
#' Generate heatmap of metagenes derived from factorization of count data.
#' 
#' Wrapper for \code{\link[stats]{heatmap}} to display metagenes and
#' associated basis matrix element magnitudes. Factorization results inside
#' an object specified by its rank value will be retrieved, and metagene
#' sets identified from clusters.
#' 
#' @param object Object of class \code{scNMFSet}.
#' @param rank Rank value for which the gene map is to be displayed. 
#'   The object must contain the corresponding slot (one element of 
#'        \code{basis(object)[[k]]} for which \code{ranks(object)[[k]]==rank}.
#' @param markers Vector of gene names containing markers to be included 
#'         in addition to the metagenes. All entries of \code{rowData(object)}
#'         matching them will be added to the metagene list.
#' @param subtract.mean Process each rows of basis matrix \code{W} by 
#'        standardization using the mean of elements within the row.
#' @param log If \code{TRUE}, \code{subtract.mean} uses geometric mean
#'        and division. Otherwise, use arithmetic mean and subtraction.
#' @param max.per.cluster Maximum number of metagenes per cluster.
#' @param Colv \code{NA} suppresses reordering and dendrogram of clusters
#'        along the column. See \code{\link[stats]{heatmap}}.
#' @param col Colors for the cluster panels on the left and top.
#' @param gene.names Names to be used in the plot for genes.
#' @param main Title of plot.
#' @param ... Other arguments to be passed to \code{\link{heatmap}}, 
#'            \code{\link{image}}, and \code{\link{plot}}.
#'            
#' @details If \code{object} contains multiple ranks, only the requested 
#'   rank's basis matrix W will be displayed. The genes displayed in rows
#'      are selected by "max" scheme
#'     [Carmona-Saez, BMC Bioinformatics (2006), 
#'    \url{https://doi.org/10.1186/1471-2105-7-54}]:
#'      for each cluster (\code{k in 1:ncol}), 
#'      rows of W are sorted by decreasing order
#'      of \code{W[,k]}. Marker genes for \code{k} are those among the top
#'      \code{nmarker} for which \code{W[,k]} is maximum within each row.
#' 
#' @return \code{NULL}
#' @examples  
#' set.seed(1)
#' x <- simulate_data(nfeatures=10,nsamples=c(20,20,60))
#' rownames(x) <- seq_len(10)
#' colnames(x) <- seq_len(100)
#' s <- scNMFSet(count=x,rowData=seq_len(10), colData=seq_len(100))
#' s <- vb_factorize(s,ranks=seq(2,5))
#' plot(s)
#' gene_map(s, rank=3)
#' @export
gene_map <- function(object, rank, markers=NULL, subtract.mean=TRUE,
                     log=TRUE, max.per.cluster = 10, Colv=NA,
                     gene.names=NULL, main='Genes', col=NULL, ...){
  
  if(missing(rank)) rank <- ranks(object)[1] # by default the first rank
  w <- basis(object)[ranks(object)==rank][[1]]
  if(subtract.mean){
    if(log) w <- log10(w)
    w <- w - rowMeans(w)
    if(log) w <- 10^w
  }
  colnames(w) <- seq_len(rank)
  if(!is.null(gene.names)) rownames(w) <- gene.names
  if(dim(w)[1] <= max.per.cluster) select <- rownames(w)
  else select <- gene_select(w, markers, max.per.cluster= max.per.cluster)
  w <- w[select,]
  if(is.null(col)) ccol <- grDevices::rainbow(n = dim(w)[2])
  else ccol <- col
  gid <- apply(w,1,which.max)
  stats::heatmap(w, Colv = Colv, RowSideColors = ccol[gid], 
                 ColSideColors = ccol, revC = TRUE, main =main, 
                 col = RColorBrewer::brewer.pal(n=9,'YlOrRd'),...)
}

#' Plot heatmap of basis matrix
#' 
#' Generate heatmap of features derived from factorization of count data.
#' 
#' This function uses \code{image()} and is more flexible than 
#' \code{gene_map}.
#' @param object Object of class \code{scNMFSet}.
#' @param basis.matrix Basis matrix can be supplied instead of \code{object}.
#' @param rank Rank value for which the gene map is to be displayed. 
#'   The object must contain the corresponding slot (one element of 
#'        \code{basis(object)[[k]]} for which \code{ranks(object)[[k]]==rank}.
#' @param markers Vector of gene names containing markers to be included 
#'         in addition to the metagenes. All entries of \code{rowData(object)}
#'         matching them will be added to the metagene list.
#' @param subtract.mean Process each rows of basis matrix \code{W} by 
#'        standardization using the mean of elements within the row.
#' @param log If \code{TRUE}, \code{subtract.mean} uses geometric mean
#'        and division. Otherwise, use arithmetic mean and subtraction.
#' @param max.per.cluster Maximum number of metagenes per cluster.
#' @param feature.names Names to be used in the plot for features.
#' @param perm Permutation of cluster IDs.
#' @param main Main title.
#' @param cscale Colors for heatmap.
#' @param cex.cluster Cluster ID label size. 
#' @param cex.feature Feature ID label size.
#' @param mar Margins for \code{graphics::par}.
#' @param ... Other arguments to be passed to \code{\link{image}}, and 
#'        \code{\link{plot}}.
#'            
#' @details If \code{object} contains multiple ranks, only the requested 
#'   rank's basis matrix W will be displayed. As in \code{gene_map}, the features
#'   displayed in rows are selected by "max" scheme
#' @return \code{NULL}
#' @examples  
#' set.seed(1)
#' x <- simulate_data(nfeatures=10,nsamples=c(20,20,60))
#' rownames(x) <- seq_len(10)
#' @examples  
#' set.seed(1)
#' x <- simulate_data(nfeatures=10,nsamples=c(20,20,60))
#' rownames(x) <- seq_len(10)
#' colnames(x) <- seq_len(100)
#' s <- scNMFSet(count=x,rowData=seq_len(10), colData=seq_len(100))
#' s <- vb_factorize(s,ranks=seq(2,5))
#' plot(s)
#' feature_map(s, rank=3)
#' @export
feature_map <- function(object, basis.matrix=NULL, rank, markers=NULL, 
                        subtract.mean=TRUE, log=TRUE, 
                        max.per.cluster = 10, feature.names=NULL, perm=NULL,
                        main='Feature map', cscale=NULL, 
                        cex.cluster=1, cex.feature=0.5, mar=NULL, ...){
  
  if(is.null(cscale)) cscale <- RColorBrewer::brewer.pal(n=9,'YlOrRd')
  if(missing(rank)){
     if(!is.null(basis.matrix)) rank <- ncol(basis.matrix)
     else rank <- ranks(object)[1] # by default the first rank
  }
  if(is.null(perm)) perm <- seq_len(rank)

  if(is.null(basis.matrix)){
    w <- basis(object)[ranks(object)==rank][[1]][,perm]
    meta <- meta_genes(object, rank=rank, subtract.mean=subtract.mean,
                       gene_names=feature.names,
                       log=log, max.per.cluster=max.per.cluster)
    colnames(w) <- seq_len(rank)
  }
  else{
    w <- basis.matrix
    meta <- meta_genes(basis.matrix=w, rank=rank, subtract.mean=subtract.mean,
                       gene_names=feature.names,
                       log=log, max.per.cluster=max.per.cluster)
  }

  if(!is.null(feature.names)) rownames(w) <- feature.names
#  if(subtract.mean){
    if(log) w <- w/exp(rowMeans(log(w)))
    else w <- w - rowMeans(w)
#  }

  meta <- meta[perm]
  if(!is.null(markers)){
    markers <- markers[markers %in% rownames(w)]
    markers <- markers[!(markers %in% unlist(meta))] # markers in meta-gene list
  }
  gid <- apply(w[markers,],1, which.max)
  
  w1 <- w[c(unlist(meta),markers),seq_len(rank)]
  idx <- c()
  step <- c()
  for(k in seq_len(rank)){
    tmp <- meta[[k]]
    tmp <- c(tmp, markers[gid==k])
    step <- c(step, length(tmp))
    idx <- c(idx,tmp)
  }
  w1 <- w1[idx,]
  nc <- ncol(w1)
  nr <- nrow(w1)
  
  x <- sweep(w1, 1, rowMeans(w1), check.margin=TRUE)
  sx <- apply(x,1,stats::sd)
  x <- sweep(x, 1, sx, '/', check.margin=FALSE)
  
  if(is.null(mar)) mar <- c(5.1,4.1,4.1,4)
  par(mar=mar)
  graphics::image(seq_len(nc), seq_len(nr), t(x)[,seq(nr,1)], xlim=0.5+c(0,nc),
        ylim=0.5+c(0,nr), axes=FALSE, xlab='',ylab='',col=cscale)
  graphics::axis(1,seq_len(nc), labels=seq_len(nc), las=1, line=-1.0,tick=0, 
       cex.axis=cex.cluster)
  col <- rep('black',nr)
  graphics::text(x=rank+0.7,y=seq(nr,1), labels=rownames(w1), col=col,xpd=NA, 
       cex=cex.feature, adj=0)
  y <- nrow(w1) + 0.5
  graphics::segments(x0=0.5, x1=rank+2, lty=2, y0=y, y1=y, xpd=NA, lwd=0.5)
  for(k in seq_len(rank)){
    graphics::text(x=-0.1, y=y-1, label=k, cex=cex.cluster, xpd=NA)
    y <- y-step[k]
    graphics::segments(x0=0.5, x1=rank+2, lty=2, y0=y, y1=y, xpd=NA, lwd=0.5)
  }
  graphics::title(adj=0.5,main=main)
}
#' Plot heatmap of clustering coefficient matrix
#' 
#' Retrieve a coefficient matrix \code{H}
#' derived from factorization by rank value
#' and generate heatmap of its elements.
#' 
#' @param object Object of class \code{scNMFSet}.
#' @param rank Rank value for which the cell map is to be displayed. 
#'   The object must contain the corresponding slot: one element of 
#'             \code{coeff(object)[[k]]} for which 
#'             \code{ranks(object)[[k]]==rank}.
#' @param main Title of plot.
#' @param ... Other arguments to be passed to \code{\link{heatmap}}, 
#' \code{\link{image}},
#'            and \code{\link{plot}}.
#' @return \code{NULL}
#' @examples
#' set.seed(1)
#' x <- simulate_data(nfeatures=10,nsamples=c(20,20,60))
#' rownames(x) <- seq_len(10)
#' colnames(x) <- seq_len(100)
#' s <- scNMFSet(count=x,rowData=seq_len(10),colData=seq_len(100))
#' s <- vb_factorize(s,ranks=seq(2,5))
#' plot(s)
#' cell_map(s, rank=3)
#' @export
cell_map <- function(object, rank, main = 'Cells', ...){
  
  if(missing(rank)) rank <- ranks(object)[1]
  h <- coeff(object)[ranks(object) == rank][[1]]
  nrow <- nrow(h)
  ccol <- grDevices::rainbow(n = nrow)
  cid <- apply(h,2, which.max)
  labCol <- if(dim(h)[2]>10) "" else colnames(h)
  stats::heatmap(h, Rowv = NA, ColSideColors = ccol[cid], RowSideColors = ccol, 
    revC = TRUE,labCol = labCol, main = main, 
    col = RColorBrewer::brewer.pal(n=9,'YlOrRd'), ...)
}

#' Find metagenes from basis matrix
#' 
#' Retrieve a basis matrix from an object and find metagenes.
#' 
#' @param object Object of class \code{scNMFSet}.
#' @param rank Rank value for which metagenes are to be found.
#' @param basis.matrix Instead of an object containing basis 
#'     matrices, the matrix itself can be provided.
#' @param max.per.cluster Maximum number of metagenes per cluster.
#' @param gene_names Names of genes to replace row names of basis matrix.
#' @param subtract.mean Standardize the matrix elements with means 
#'        within each row.
#' @param log Use geometric mean and division instead of arithmetic 
#'        mean and subtraction with \code{subtract.mean}.
#' @return List of vectors each containing metagene names of clusters.
#' @examples
#' set.seed(1)
#' x <- simulate_data(nfeatures=10,nsamples=c(20,20,60))
#' rownames(x) <- seq_len(10)
#' colnames(x) <- seq_len(100)
#' s <- scNMFSet(count=x,rowData=seq_len(10),colData=seq_len(100))
#' s <- vb_factorize(s,ranks=seq(2,5))
#' meta_genes(s, rank=4)
#' @export
meta_genes <- function(object, rank, basis.matrix=NULL, 
                       max.per.cluster=10,gene_names=NULL,
                       subtract.mean=TRUE,log=TRUE){
  
  if(is.null(basis.matrix)){
    idx <- ranks(object)==rank
    w <- basis(object)[idx][[1]]
    if(subtract.mean){
      if(log) w <- log10(w)
      w <- w - rowMeans(w)
      if(log) w <- 10^w
    }
  } else{
    w <- basis.matrix
    rank <- ncol(w)
  }
  if(!is.null(gene_names)) rownames(w) <- gene_names
  nmax <- min(max.per.cluster, nrow(w))
  select <- vector('list',rank)
  for(k in seq_len(rank)){
    idx <- order(w[,k],decreasing=TRUE)
    v <- w[idx,]
    itmp <- NULL
    for(i in seq_len(nrow(v))){
        x <- v[i,] 
        ix <- order(x,decreasing=TRUE)
        flag <- k==ix[1] 
        if(!flag) next
        xp <- log(mean(exp(x[ix[-1]])))
        itmp <- c(itmp,i)
    }
    tmp <- rownames(v)[itmp]
    if(length(tmp) > nmax) tmp <- tmp[seq_len(nmax)]
    select[[k]] <- tmp
  }
  select
}

gene_select <- function(w, markers = NULL, max.per.cluster = 10){
  
  rank <- dim(w)[2]
  select <- c()
  for(k in seq_len(rank)){
    nmax <- min(max.per.cluster, dim(w)[1])
    if(!is.null(markers)){
      select <- c(select, markers[markers %in% rownames(w)])
      w <- w[!rownames(w) %in% markers, ]
    }
    v <- w[order(w[,k],decreasing=TRUE),]
    flag <- apply(v,1,function(x){x[k]==max(x)})
    tmp <- rownames(v)[which(flag)]
    if(length(tmp) > nmax) tmp <- tmp[seq_len(nmax)]
    select <- c(select, tmp)
  }
  unlist(select)
}

#' Visualize clusters
#' 
#' Use tSNE to generate two-dimensional map of coefficient matrix.
#' 
#' It retrieves a coefficient matrix \code{H} 
#' from an object and use its elements
#' to assign each cell into clusters. 
#' t-Distributed Stochastic Neighbor Embedding (t-SNE; 
#' \url{https://lvdmaaten.github.io/tsne/}) is used to visualize the 
#' clustering
#' in 2D. Also plotted is the distribution of cell counts for all clusters.
#' 
#' @param object \code{scNMF} object.
#' @param rank Rank value to extract from \code{object}.
#' @param verbose Print tSNE messages.
#' @param cex Symbol size in tSNE plot
#' @param cex.names Font size of labels in count barplot.
#' @param ... Other parameters to send to \code{Rtsne}.
#' @return \code{NULL}
#' @examples
#' set.seed(1)
#' x <- simulate_data(nfeatures=10,nsamples=c(20,20,60,40,30))
#' rownames(x) <- seq_len(10)
#' colnames(x) <- seq_len(170)
#' s <- scNMFSet(count=x,rowData=seq_len(10),colData=seq_len(170))
#' s <- vb_factorize(s,ranks=seq(2,5))
#' visualize_clusters(s,rank=5)
#' @export
#' @importFrom graphics par
#' @importFrom graphics points
visualize_clusters <- function(object, rank, verbose=FALSE, cex=1, 
                               cex.names = 0.7, ...){
  
  if(missing(rank)){
    rid <- 1
    rank <- ranks(object)[1]
  }
  h <- coeff(object)[ranks(object) == rank][[1]]
  tsne <- Rtsne::Rtsne(t(h), verbose=verbose, ...)
  cid <- apply(h,2,which.max)       # cluster assignment
  col <- grDevices::rainbow(n=dim(h)[1])
  color <- col[cid]
  
  par(mfrow=c(1,2))
  plot(x=tsne$Y, pch=21,bg=color,main='Clusters', xlab='tSNE1',ylab='tSNE2',
       lwd=0.5, cex=cex)
  graphics::barplot(table(cid), names.arg=rownames(h),
          col=col,log='y', main='Cell counts', cex.names=cex.names,
          las=2)
  return(invisible(object))
}

#' Generate simulated data for factorization
#' 
#' Use one of two schemes to generate simulated data suitable for 
#' testing factorization.
#' 
#' In one scheme (\code{generate.factors = TRUE}), simulated factor 
#'   matrices 
#' \code{W} and \code{H} are used to build count data \code{X = WH}.
#' In the second scheme, factor matrices are not used and \code{X} is 
#'   sampled directly from \code{r} (rank requested) sets of 
#'   multinomial distributions.
#' 
#' @param nfeatures Number of features \code{m} (e.g., genes).
#' @param nsamples Vector of sample sizes in each cluster. 
#'    Rank \code{r} is equal to 
#'        the length of this vector. Sum of elements is the total 
#'        sample size \code{n}.
#' @param generate.factors Generate factor matrices \code{W} and \code{H},
#'        each with dimension \code{n x r} and \code{r x n}. If \code{FALSE},
#'        factor matrices are not used and count data are generated 
#'        directly from
#'        \code{r} multinomials for \code{m} genes.
#' @param nfactor Total RNA count of multinomials for each cluster with 
#'        \code{generate.factors = FALSE}. Small \code{nfactor} will 
#'        yield sparse count matrix.
#' @param alpha0 Variance parameter of Dirichlet distribution from which 
#'    multinomial probabilities are sampled with 
#'    \code{generate.factors = FALSE}.
#' @param shuffle Randomly permute rows and columns of count matrix.
#' @return If \code{generate.factors = TRUE}, list of components 
#'   \code{w} (basis matrix, \code{nfeatures x rank}),
#'         \code{h} (coefficient matrix, \code{rank x ncells}, where 
#'         \code{ncells}
#'         is equal to \code{n}, the sum of \code{nsamples}), and 
#'         \code{x}, a matrix of Poisson deviates with mean \code{W x H}.
#'         If \code{generate.factors = FALSE}, only the count matrix 
#'         \code{x} is in the list.
#' @examples
#' set.seed(1)
#' x <- simulate_data(nfeatures=10,nsamples=c(20,20,60,40,30))
#' s <- scNMFSet(x)
#' s
#' @export
simulate_data <- function(nfeatures, nsamples, generate.factors=FALSE, 
                          nfactor=10, alpha0=0.5, shuffle=TRUE){
  rank <- length(nsamples)
  if(generate.factors){
    if(nfeatures<rank) stop('No. of features too small for rank requested.')
    a <- rep(floor(nfeatures/rank),rank-1)
    a <- c(a,nfeatures-sum(a))
    H <- W <- NULL
    for(k in seq_len(rank)){
      tmp <- matrix(0, nrow=rank, ncol=nsamples[k])
      tmp[k,] <- 1
      H <- cbind(H, tmp)
      if(a[k]==0) next
      tmp2 <- matrix(0, nrow=a[k], ncol=rank)
      tmp2[, k] <- stats::rmultinom(n=1, size=a[k]*5, 
                    prob=rep(1,a[k]))
      W <- rbind(W, tmp2)
    }
    wh=W %*% H
    x <- apply(wh, c(1,2), function(x){stats::rpois(n=1, lambda=x)})
    if(shuffle){
      cel <- sample(seq_len(ncol(x)),size=ncol(x),replace=FALSE)
      x <- x[,cel]
      H <- H[,cel]
      gen <- sample(seq_len(nrow(x)),size=nrow(x),replace=FALSE)
      x <- x[gen,]
      W <- W[gen,]
    }
    return(list(w=W, h=H, x=matrix(x,nrow=nfeatures, ncol=sum(nsamples))))
  } else{
    x <- NULL
    q <- gtools::rdirichlet(n=rank,alpha=rep(alpha0,nfeatures))
    for(k in seq_len(rank)){
      x <- cbind(x, stats::rmultinom(n=nsamples[k], 
                             size=nfeatures*nfactor, prob=q[k,]))
    }
    if(shuffle) 
      x <- x[,sample(seq_len(ncol(x)),size=ncol(x),replace=FALSE)]
    return(x)
  }
}

#' Simulate factor matrices and data using priors
#' 
#' Under Bayesian formulation, use prior distributions of factor matrices
#' and generate simulated data
#' 
#' Basis \code{W} and coefficient matrices \code{H} are sampled from 
#' gamma distributions (priors) with shape (\code{aw,ah}) and mean
#' (\code{bw,bh}) parameters. Count data \code{X} are sampled from Poisson
#' distribution with mean values given by \code{WH}.
#' 
#' @param nrow Number of features (genes).
#' @param ncol Number of cells (samples).
#' @param rank Rank (ncol of W, nrow of H).
#' @param aw Shape parameter of basis prior.
#' @param bw Mean of basis prior. Scale parameter is equal to \code{aw/bw}.
#' @param ah Shape parameter of coefficient prior.
#' @param bh Mean of coefficient prior. Scale parameter is equal to 
#'    \code{ah/bh}.
#' @return List with elements \code{w}, \code{h}, and \code{x}, each 
#'    containing basis, coefficient, and count matrices.
#' @examples
#' set.seed(1)
#' x <- simulate_whx(nrow=50,ncol=100,rank=5)
#' s <- scNMFSet(count=x$x)
#' s <- vb_factorize(s,ranks=seq(2,8),nrun=5)
#' plot(s)  
#' @export
simulate_whx <- function(nrow, ncol, rank, aw=0.1, bw=1, ah=0.1, bh=1){
  
  w <- stats::rgamma(n=nrow*rank, shape=aw, scale=bw/aw)
  w <- matrix(w, nrow=nrow, ncol=rank)
  
  h <- stats::rgamma(n=rank*ncol, shape=ah, scale=bh/ah)
  h <- matrix(h, nrow=rank, ncol=ncol)
  
  lambda <- w%*%h
  x <- apply(lambda, seq(1,2), 
             function(x){stats::rpois(n=1,lambda=x)})
  i <- rowSums(x) > 0
  j <- colSums(x) > 0
  x <- x[i,j]
  w <- w[i,]
  h <- h[,j]
  rownames(x) <- seq_len(nrow(x))
  colnames(x) <- seq_len(ncol(x))
  
  list(w=w, h=h, x=x)
}

#' Write 10x data files
#' 
#' Use an object and write count and annotation files in 10x format.
#'  
#' @param object Object of class \code{scNMFSet} containing count data
#' @param dir Directory where files are to be written. 
#' @param count File name for count matrix. 
#' @param genes File name for gene annotation.
#' @param barcodes File name for cell annotation.
#' @param quote Suppress quotation marks in output files.
#' @return \code{NULL}
#' @examples
#' set.seed(1)
#' x <- matrix(rpois(n=12,lambda=3),4,3)
#' rownames(x) <- seq_len(4)
#' colnames(x) <- seq_len(3)
#' s <- scNMFSet(count=x,rowData=seq_len(4),colData=seq_len(3))
#' write_10x(s,dir='.')
#' @export
write_10x <- function(object, dir, count='matrix.mtx',
                      genes='genes.tsv', barcodes='barcodes.tsv',
                      quote=FALSE){
  
  count <- paste0(dir, '/', count)
  genes <- paste0(dir, '/', genes)
  barcodes <- paste0(dir, '/', barcodes)
  x <- counts(object)
  x <- as(x,'sparseMatrix')
  Matrix::writeMM(as(x,'Matrix'),file=count)
  g <- rowData(object)
  rownames(g) <- rownames(rowData(object))
  utils::write.table(g,file=genes,col.names=FALSE,quote=quote,sep=' ',
              row.names=FALSE)
  utils::write.table(colData(object),file=barcodes,col.names=FALSE,
                     quote=FALSE,sep=' ',row.names=FALSE)
  return(invisible(object))
}

#' Assign cells into clusters
#' 
#' Use factorization results in an object to assign cells into clusters.
#' 
#' @param object Object of class \code{scNMFSet}
#' @param rank Rank value whose factor matrices are to be used for 
#'        assignment.
#' @return Vector of length equal to the number of cells containing 
#'      cluster ID numbers of each cell.
#' @examples
#' set.seed(1)
#' x <- simulate_whx(nrow=50,ncol=100,rank=5)
#' s <- scNMFSet(count=x$x)
#' s <- vb_factorize(s,ranks=seq(2,8),nrun=5)
#' cid <- cluster_id(s, rank=5)
#' table(cid)
#' @export
cluster_id <- function(object, rank=2){
  
  h <- coeff(object)[ranks(object) == rank][[1]]
  cid <- apply(h, 2, which.max)
  names(cid) <- colnames(object)
  cid
}

#' Write meta genes to a file
#' 
#' Write a csv file of meta gene lists from input list
#' @param meta List of meta genes output from \code{meta_genes}
#' @param file Output file name
#' @return \code{NULL}
#' @export
#' @examples
#' set.seed(1)
#' x <- simulate_whx(nrow=50, ncol=100, rank=5)
#' s <- scNMFSet(x$x)
#' s <- vb_factorize(s, ranks=seq(2,8), nrun=5)
#' plot(s)
#' m <- meta_genes(s, rank=5)
#' write_meta(m, file='meta.csv')
write_meta <- function(meta,file){
  
  rank <- length(meta)
  nmax <- 0
  for(k in seq_len(rank))
    if(length(meta[[k]])> nmax) nmax <- length(meta[[k]])
  dat <- matrix('',nrow=nmax,ncol=rank)
  for(k in seq_len(rank))
    dat[seq_len(length(meta[[k]])),k] <- meta[[k]]
  rownames(dat) <- seq_len(nmax)
  colnames(dat) <- seq_len(rank)
  utils::write.csv(dat,file=file)
  return(invisible(meta))
}

#' Determine optimal rank
#' 
#' Takes as main argument \code{scNMFSet} object containing factorized output
#' and estimate the optimal rank.
#' 
#' @param object \code{scNMFSet} object containing factorization output, or 
#'        data frame containing the rank-evidence profile.
#' @param df Degrees of freedom for split fit. Upper bound is the total number of
#'        data points (number of rank values scanned).
#' @param BF.threshold Bayes factor threshold for statistical threshold. 
#' @param type \code{c(1,2)}. Type 1 is where there is a clear maximum. Type 2 
#'        is where marginal likelihood reaches a maximal level and stays constant.
#'        If omitted, the type will be inferred from data.
#' @param m Number of features (e.g., genes) in the count matrix. Only necessary when
#'        \code{object} is of type \code{data.frame}.
#' @return List containing \code{type} and \code{ropt} (optimal rank).
#' 
#' @details The input object is used along with Bayes factor threshold to determine the
#'          heterogeneity type (1 or 2) and the optimal rank. 
#'          If evidence(rank 1)/evidence(rank2) > \code{BF.treshold}, rank 1 is favorable than rank 2.
#' @examples
#' set.seed(1)
#' x <- simulate_whx(nrow=50, ncol=100, rank=5)
#' s <- scNMFSet(x$x)
#' s <- vb_factorize(s, ranks=seq(2,8), nrun=5)
#' plot(s)
#' optimal_rank(s)
#' @export
optimal_rank <- function(object, df=10, BF.threshold=3, type=NULL, m=NULL){
  
  if(is(object,'scNMFSet')){
    me <- measure(object)[,c(1,2)]
    m <- nrow(object)
  }
  else if(is(object,'data.frame')){
    me <- object[,c(1,2)]
    if(is.null(m)) stop('No. of rows unknown')
  }
  else stop('Inappropriate class of object')
  
  df <- min(df,nrow(me))
  fs <- stats::smooth.spline(x=me[,1],y=me[,2],df=df)
  rst <- fs$x[which.max(fs$y)]     # arg max_r (L)
  bf <- log(BF.threshold)/m
  
  if(is.null(type)){    # determine the type
    rmax <- max(me[,1])
    flag <- abs(fs$y-max(fs$y)) <= bf
    range <- fs$x[flag]  # rank values within the threshold around optimum
    if(rmax %in% range) type <- 2
    else type <- 1
  }
  
  if(type==1) ropt <- rst
  else{
    sl <- slope(fs$y,fs$x)
    if(sum(sl < bf)>0) 
      idx <- which(sl < bf)[1]
    else
      idx <- nrow(me)
    ropt <- fs$x[idx]
  }
  
  return(list(type=type, ropt=ropt))
}

slope <- function(y,x){
  
  n <- length(x)
  s <- rep(0,n)
  s[1] <- (y[2]-y[1])/(x[2]-x[1])
#  for(i in seq(2,n-1))
#    s[i] <- mean(c((y[i+1]-y[i])/(x[i+1]-x[i]),
#                   (y[i]-y[i-1])/(x[i]-x[i-1])))
#  s[n] <- (y[n]-y[n-1])/(x[n]-x[n-1])
  for(i in seq(2,n-1))
    s[i] <- (y[i+1]-y[i])/(x[i+1]-x[i])
  s[n] <- s[n-1]
  
  return(s)
}

#' Meta gene table with CV
#'
#' Generates meta gene table with coefficient of variation 
#' @param object Main object containing factorization outcome
#' @param rank Rank for which meta gene is to be found
#' @param basis.matrix Basis matrix to work with. Only necessary when 
#'        \code{object} is \code{NULL}.
#' @param dbasis Variance of basis matrix. Only necessary when 
#'        \code{object} is \code{NULL}.
#' @param max.per.cluster Maximum meta genes per cluster.
#' @param gene_names Name of genes. If \code{NULL}, will be taken from row names.
#' @param subtract.mean Standardize magnitudes of basis elements by subtracting mean
#' @param log Use geometric mean.
#' @param cv.max Upper bound for CV in selecting meta genes.
#' @return Data frame with meta genes and their CV in each column.
#' @examples
#' set.seed(1)
#' x <- simulate_whx(nrow=50, ncol=100, rank=5)
#' s <- scNMFSet(x$x)
#' s <- vb_factorize(s, ranks=seq(2,8), nrun=5)
#' plot(s)
#' meta_gene.cv(s, rank=5)
#' @export
meta_gene.cv <- function(object=NULL, rank, basis.matrix=NULL, 
                         dbasis=NULL, max.per.cluster=100,
                         gene_names=NULL, subtract.mean=TRUE,
                         log=TRUE, cv.max=Inf){
  
  if(is.null(basis.matrix)){
    idx <- ranks(object)==rank
    w <- basis(object)[idx][[1]]
    cw <- dbasis(object)[idx][[1]]/w
    if(subtract.mean){
      if(log) w <- log10(w)
      w <- w - rowMeans(w)
      if(log) w <- 10^w
    }
  } else{
    w <- basis.matrix
    rank <- ncol(w)
    cw <- dbasis/w
  }
  if(!is.null(gene_names)) rownames(w) <- rownames(cw) <- gene_names
  nmax <- min(max.per.cluster, nrow(w))

  maxrow <- 0  
  for(k in seq_len(rank)){
    x <- data.frame(rep('',nmax), rep(NA,nmax), rep(NA,nmax),
                    stringsAsFactors=FALSE)
    names(x) <- c(paste0('Gene_',k), paste0('W_',k),paste0('CV_',k))
    idx <- order(w[,k],decreasing=TRUE)[seq_len(nmax)]
    v <- w[idx,]
    cv <- cw[idx,]
    sig <- which(cv[,k] <= cv.max)
    nsig <- seq_len(length(sig))
    x[nsig,1] <- rownames(v)[sig]
    x[nsig,2] <- v[sig,k]
    x[nsig,3] <- cv[sig,k]
    if(length(nsig)>maxrow) maxrow <- length(nsig)
    if(k==1) dat <- x
    else dat <- cbind(dat, x)
  }
  dat <- dat[seq_len(maxrow),]

  return(dat)
}

# single update step of ML-NMF
nmf_updateR <- function(x,w,h,n,m,r, prior=FALSE, gamma.a, gamma.b){

  x <- as.matrix(x)
  w <- as.matrix(w)
  h <- as.matrix(h)

  up <- h*(t(w) %*% (x/(w %*% h)))
  down <- matrix(rep(colSums(w),m),nrow=r,ncol=m,byrow=FALSE)
  if(prior){
    up <- up + gamma.a-1
    down <- down + gamma.a/gamma.b
  }
  h <- up/down
  h[h < .Machine$double.eps] <- .Machine$double.eps
  
  up <- w*((x/(w %*% h)) %*% t(h))
  down <- matrix(rep(rowSums(h),n),nrow=n,ncol=r,byrow=TRUE)
  if(prior){
    up <- up + gamma.a-1
    down <- down + gamma.a/gamma.b
  }
  w <- up/down
  w[w < .Machine$double.eps] <- .Machine$double.eps
  
  list(ew=w,eh=h)
}

# initialize w and h
init <- function(nrow,ncol,mat,rank,max=1.0){
  w <- matrix(stats::runif(n=nrow*rank),nrow=nrow,ncol=rank)
  rownames(w) <- rownames(mat)
  colnames(w) <- seq_len(rank)
  h <- matrix(stats::runif(n=rank*ncol),nrow=rank,ncol=ncol)
  rownames(h) <- seq_len(rank)
  colnames(h) <- colnames(mat)
  list(ew=w,eh=h)
}

likelihood <- function(mat,w,h){

  wh <- as.vector(w %*% h)
  amat <- as.vector(mat)
  x <- sum(amat*log(wh)-wh)
  z <- amat[amat > 0]
  x <- x + sum(-z*log(z)+z)
  x/nrow(mat)/ncol(mat)

}

connectivity <- function(h){

  ncol <- ncol(h)
  cid <- c()
  for(j in seq_len(ncol))
    cid <- c(cid, which.max(h[,j])[1])
  cnn <- outer(cid,cid,'==')
  t(cnn)[lower.tri(t(cnn))]

}

dispersion <- function(cnn,nc){

  con <- sum((cnn-0.5)^2)
  1/nc+8*con/nc^2

}

cophenet <- function(conav, nc, method='average'){
  
  tmp <- matrix(0,nrow=nc,ncol=nc)
  tmp[lower.tri(tmp)] <- 1-conav
  d <- stats::as.dist(tmp)
  h <- stats::hclust(d, method=method)
  coph <- stats::cophenetic(h)
  stats::cor(d,coph)

}

#' Maximum likelihood factorization
#' 
#' Performs single or multiple rank NMF factorization of count matrix using 
#' maximum likelihood
#' 
#' The main input is the \code{scNMFSet} object with count matrix.
#' This function performs non-negative factorization and fills in the empty
#' slots \code{basis}, \code{coeff}, and \code{ranks}.
#' 
#' @param object \code{scNMFSet} object containing count matrix.
#' @param ranks Rank for factorization; can be a vector of multiple values.
#' @param nrun No. of runs with different initial guess.
#' @param randomize Boolean; if \code{TRUE}, input matrix is randomized.
#' @param nsmpl No. of randomized samples to average over.
#' @param verbose The verbosity level: 
#'        3, each iteration output printed;
#'        2, each run output printed; 
#'        1, each randomized sample output printed;
#'        0, silent.
#' @param progress.bar Display progress bar when \code{nrun > 1 } and 
#'        \code{verbose = 1}.
#' @param Itmax Maximum no. of iteration.
#' @param ncnn.step Minimum no. of steps with no change in connectivity matrix 
#'        to achieve convergence.
#' @param criterion If \code{'likelihood'}, iteration stops when fractional 
#'        changes in likelihood is below tolerance \code{Tol}. If 
#'        \code{criterion = 'connectivity'}, iteration stops when connectivity 
#'        matrix does not change for at least \code{ncnn.step} steps.
#' @param linkage Method to be sent to \code{hclust} in 
#'        calculating cophenetic correlation. 
#' @param Tol Tolerance for checking convergence with 
#'       \code{criterion = 'likelihood'}.
#' @param store.connectivity Returns a list also containing connectivity data.
#'        
#' @return Object of class \code{scNMFSet} with factorization slots filled.
#' 
#' @details When run with multiple values of \code{ranks}, 
#'         factorization is repeated for each rank and the slot \code{measure} 
#'         contains quality measures of the ranks. The quality measure 
#'         \code{likelihood} is negative the KL distance of the fit to the 
#'         target. With \code{nrun > 1}, the likelihood is the maximum 
#'         among all runs. 
#'         
#'         The quality measure \code{dispersion} is the scalar
#'         measure of how far the connectivity matrix is from 0, 1. With 
#'         increasing \code{nrun}, \code{dispersion} decreases from 1. 
#'         \code{nrun} should be chosen such that \code{dispersion} does not 
#'         change appreciably.
#'         With randomization, \code{count} matrix of \code{object} 
#'         is shuffled. 
#'         \code{nsmpl} can be used to average over multiple permutations. This 
#'         averaging applies to each quality measure under a given rank. 
#' @examples
#' set.seed(1)
#' x <- simulate_data(nfeatures=10,nsamples=c(20,20,60,40,30))
#' s <- scNMFSet(count=x)
#' s <- factorize(s,ranks=seq(2,8),nrun=5)
#' plot(s)
#' @export
factorize <- function(object, ranks=2, nrun=20, randomize=FALSE, 
                      nsmpl=1, verbose=2, progress.bar=TRUE, 
                      Itmax=10000, ncnn.step=40, criterion='likelihood',
                      linkage='average', Tol=1e-5,
                      store.connectivity=FALSE){
  
  mat <- counts(object)  
  
  nullr <- sum(Matrix::rowSums(mat)==0)
  nullc <- sum(Matrix::colSums(mat)==0)
  if(nullr>0) stop('Input matrix contains empty rows')
  if(nullc>0) stop('Input matrix contains empty columns')
  
  nrow <- dim(mat)[1]
  ncol <- dim(mat)[2]
  
  nrank <- length(ranks)  # rank values requested

  wdat <- vector('list',nrank)
  hdat <- vector('list',nrank)
  npair <- ncol*(ncol-1)/2
  rdat <- ddat <- cdat <- vector('list',nrank)
  rave <- dave <- coav <- rste <- cste <- dste <- rep(0,nrank)
  if(randomize) mat0 <- mat
  
  for(irank in seq_len(nrank)){
    
    rank <- ranks[irank]
    if(verbose > 0) cat('Rank ',rank,'\n',sep='')
    
    for(ismpl in seq_len(nsmpl)){
      
      conav <- rep(0,npair)
      if(randomize) mat <- apply(mat0,2,
        function(x){sample(x,size=length(x),replace=FALSE)})
      if(verbose == 1 & progress.bar) 
        pb <- utils::txtProgressBar(style = 3)
      rmax <- -Inf
      for(irun in seq_len(nrun)){
      
        if(verbose >=2 ){
          if(randomize)
            cat('Rnd.sample #',ismpl,', run #',irun,':\n')
          else
            cat('Run #',irun,':\n')
        }else if(verbose == 1 & progress.bar) 
          utils::setTxtProgressBar(pb, irun/nrun)
        
        wh <- init(nrow,ncol,mat,rank)
        
        zstep <- 0
        lkold <- -Inf
        for(it in seq_len(Itmax)){
          wh <- nmf_updateR(mat,wh$ew,wh$eh,nrow,ncol,rank)
          lk0 <- likelihood(mat,wh$ew,wh$eh)
          if(criterion=='connectivity'){
            cnn <- connectivity(wh$eh)
            if(it == 1) nchange <- npair
            else nchange <- sum(cnn!=cnn0)
          
            if(verbose >= 3)
              cat(it,': likelihood = ',lk0,', connectivity change = ', 
                  nchange,'\n')
            if(nchange == 0) zstep <- zstep+1
            else zstep <- 0
            if(zstep == ncnn.step) break
            cnn0 <- cnn
          }
          else if(criterion=='likelihood'){
            if(abs(lkold-lk0)<Tol*abs(lkold)) break
            if(verbose >=3) cat(it,': likelihood = ',lk0,'\n')
            lkold <- lk0
          }
          else stop('Unknown stopping criterion.')
        }
        cnn <- connectivity(wh$eh)
        conav <- conav + cnn
        disp <- dispersion(conav/irun,ncol)
        if(verbose >= 2) cat('Nsteps =',it,
                ', likelihood =',lk0,', dispersion =',disp,'\n\n')
        if((irun == 1 | lk0 > rmax) & !is.na(lk0)){
          rmax <- lk0
          wmax <- wh$ew
          hmax <- wh$eh
        }
      }
      if(verbose == 1 & progress.bar) close(pb)
      coph <- cophenet(conav/nrun,ncol, method=linkage)
      if(verbose >= 1) cat('Sample#',ismpl,': Max(likelihood) =',rmax,
                ', dispersion =',disp,', cophenetic =',coph,'\n')
      if(ismpl==1){
        wdat[[irank]] <- wmax
        hdat[[irank]] <- hmax
        rdat[[irank]] <- rmax
        ddat[[irank]] <- disp
        cdat[[irank]] <- coph
      } else{
        wdat[[irank]] <- wdat[[irank]]+wmax
        hdat[[irank]] <- hdat[[irank]]+hmax
        rdat[[irank]] <- c(rdat[[irank]], rmax)
        ddat[[irank]] <- c(ddat[[irank]], disp)
        cdat[[irank]] <- c(cdat[[irank]], coph)
      }
    }
    wdat[[irank]] <- wdat[[irank]]/nsmpl
    hdat[[irank]] <- hdat[[irank]]/nsmpl
    if(nsmpl>1){
      denom <- sqrt(nsmpl-1)
      rste[irank] <- stats::sd(rdat[[irank]])/denom
      dste[irank] <- stats::sd(ddat[[irank]])/denom
      cste[irank] <- stats::sd(cdat[[irank]])/denom
    }
    else{
      rste[irank] <- dste[irank] <- cste[irank] <- NA
    }
    rave[irank] <- mean(rdat[[irank]])
    dave[irank] <- mean(ddat[[irank]])
    coav[irank] <- mean(cdat[[irank]])
    if(verbose >= 1 & randomize) cat('Mean(likelihood) = ',rave[irank],
                    ', Mean(dispersion) =',dave[irank],
                    ', Mean(cophenetic) =',coav[irank],'\n\n')
  }
  object@ranks <- ranks
  object@basis <- wdat
  object@coeff <- hdat
  if(randomize)
    meas <- data.frame(rank=ranks, likelihood=rave, 
      r_se=rste, dispersion=dave, d_se=dste, cophenetic=coav, c_se=cste)
  else 
    meas <- data.frame(rank=ranks, likelihood=rave, 
              dispersion=dave, cophenetic=coav)
  measure(object) <- meas
  
  if(store.connectivity)
    object@metadata <- list(nrun=nrun, connectivity=conav/nrun)
  
  return(object)  
}

# Update hyperparameters
hyper_update <- function(hyper.update, wh, hyper, Niter=100, Tol=1e-4){
    
   if(sum(hyper.update)==0) return(hyper)
  
   aw0 <- hyper$aw
   ah0 <- hyper$ah
   lwm <- mean(log(wh$lw))
   lhm <- mean(log(wh$lh))
   ewm <- mean(wh$ew)
   ehm <- mean(wh$eh)
   bw0 <- hyper$bw
   bh0 <- hyper$bh
  
   if(hyper.update[1]+hyper.update[3]>0){
    i <- 1
    while(i<Niter){
      if(hyper.update[1])
        dw <- (log(aw0)-digamma(aw0)-ewm/bw0+1+lwm-log(bw0))/
          (1/aw0-psigamma(aw0,1))
      else dw <- 0
      if(hyper.update[3])
        dh <- (log(ah0)-digamma(ah0)-ehm/bh0+1+lhm-log(bh0))/
          (1/ah0-psigamma(ah0,1))
      else dh <- 0
      aw1 <- aw0 - dw 
      ah1 <- ah0 - dh
      while(aw1<=0){
        dw <- dw/2
        aw1 <- aw0 - dw 
      }
      while(ah1<=0){
        dh <- dh/2
        ah1 <- ah0 - dh
      }
      
      df <- mean((1-aw1/aw0)^2)+mean((1-ah1/ah0)^2)
      if(df<Tol) break
      aw0 <- aw1
      ah0 <- ah1
      i <- i+1
    }
    if(i==Niter) stop('Hyper-parameter update failed to converge')
   } else{
     aw1 <- aw0
     ah1 <- ah0
   }
   if(hyper.update[2]) bw1 <- ewm
   else bw1 <- bw0
   if(hyper.update[4]) bh1 <- ehm
   else bh1 <- ehm
   list(aw=aw1, bw=bw1, ah=ah1, bh=bh1)
}

# Single update step in Bayesian NMF inference
vbnmf_updateR <- function(x, wh, r, hyper, fudge=NULL){

   x <- as.matrix(x)
   n <- dim(x)[1]
   m <- dim(x)[2]

   lw <- as.matrix(wh$lw)
   lh <- as.matrix(wh$lh)
   ew <- as.matrix(wh$ew)
   eh <- as.matrix(wh$eh)
   aw <- hyper$aw
   bw <- hyper$bw
   ah <- hyper$ah
   bh <- hyper$bh
  
   wth <- lw %*% lh
   sw <- lw*((x/wth) %*% t(lh))
   sh <- lh*(t(lw) %*% (x/wth))
  
   alw <- aw + sw
   bew <- 1/(aw/bw + t(replicate(n, rowSums(eh))))
   ew <- alw*bew             # this update needs to precede lines below
  
   alh <- ah + sh
   beh <- 1/(ah/bh + replicate(m, colSums(ew)))
   eh <- alh*beh

   lw <- exp(digamma(alw))*bew
   lh <- exp(digamma(alh))*beh
   if(is.null(fudge)) fudge <- .Machine$double.eps
   lw[lw < fudge] <- fudge
   lh[lh < fudge] <- fudge
    
   wth <- lw %*% lh
   U1 <- -ew %*% eh - lgamma(x+1) - x*((((lw*log(lw))%*%lh) + 
          lw%*%(lh*log(lh)))/wth - log(wth))
   U2 <- -(aw/bw)*ew - lgamma(aw) + aw*log(aw/bw) + 
    alw*(1+log(bew))+lgamma(alw)
   U3 <- -(ah/bh)*eh - lgamma(ah) + ah*log(ah/bh) + 
    alh*(1+log(beh))+lgamma(alh)
   U <- sum(U1) + sum(U2) + sum(U3)
   U <- U/(n*m)  # log evidence per feature per cell
  
   w <- ew    
   h <- eh
   
   dw <- alw*bew^2
   dh <- alh*beh^2
    
   list(w=w, h=h, lw=lw, lh=lh, ew=ew, eh=eh, lkh=U, dw=dw, dh=dh)
}

# Initialize bNMF inference
vb_init <- function(nrow,ncol,mat,rank, max=1.0, hyper, initializer){
  
   if(initializer=='random'){
     w <- matrix(stats::rgamma(n=nrow*rank, shape=hyper$aw, 
           scale=hyper$bw/hyper$aw), nrow=nrow,ncol=rank)
     h <- matrix(stats::rgamma(n=rank*ncol, shape=hyper$ah, 
           scale=hyper$bh/hyper$ah), nrow=rank,ncol=ncol)
   } else if(initializer=='svd'){
     w <- matrix(0, nrow=nrow, ncol=rank)
     h <- matrix(0, nrow=rank, ncol=ncol)
     s <- svd(mat, nu=rank, nv=rank)
     d1 <- sqrt(s$d[1])
     w[,1] <- d1*s$u[,1]
     sgn <- sign(w[1,1])
     if(sgn<0) w <- -w
     h[1,] <- sgn*d1*s$v[,1]
     for(k in seq(2,rank)){
       x <- s$u[,k]
       y <- s$v[,k]
       xp <- vapply(x,function(x){if(x>0) x else 0},numeric(1))
       yp <- vapply(y,function(x){if(x>0) x else 0},numeric(1))
       xn <- vapply(x,function(x){if(x<0) -x else 0},numeric(1))
       yn <- vapply(y,function(x){if(x<0) -x else 0},numeric(1))
       xpnrm <- sqrt(sum(xp^2))
       ypnrm <- sqrt(sum(yp^2))
       mp <- xpnrm*ypnrm
       xnnrm <- sqrt(sum(xp^2))
       ynnrm <- sqrt(sum(yp^2))
       mn <- xnnrm*ynnrm
       if(mp>=mn){
         u <- xp/xpnrm
         v <- yp/ypnrm
         sig <- mp
       }else{
         u <- xn/xnnrm
         v <- yn/ynnrm
         sig <- mn
       }
       w[,k] <- sqrt(s$d[k]*sig)*u
       h[k,] <- sqrt(s$d[k]*sig)*t(v)
     }
   } else if(initializer=='svd2'){
     if(min(nrow,ncol)/2 <= rank)
       s <- svd(mat, nu=rank, nv=rank)
     else
       s <- irlba::irlba(mat, rank)
     w <- abs(s$u)
     h <- abs(diag(s$d[seq_len(rank)]) %*% t(s$v))
     scale <- hyper$bh/mean(h)
     h <- h*scale
     w <- w/scale
   }else stop('Unknown initializer')
  
   dw <- matrix(0, nrow=nrow, ncol=rank)
   dh <- matrix(0, nrow=rank, ncol=ncol)

   rownames(w) <- rownames(dw) <- rownames(mat)
   colnames(w) <- colnames(dw) <- seq_len(rank)
   rownames(h) <- rownames(dh) <- seq_len(rank)
   colnames(h) <- colnames(dh) <- colnames(mat)
  
   list(w=w, h=h, lw=w, lh=h, ew=w, eh=h, dw=dw, dh=dh)
}

#' Bayesian NMF inference of count matrix
#' 
#' Perform variational Bayes NMF and store factor matrices in object
#' 
#' The main input is the \code{scNMFSet} object with count matrix.
#' This function performs non-negative factorization using Bayesian algorithm
#' and gamma priors. Slots \code{basis}, \code{coeff}, and \code{ranks} 
#' are filled.
#' 
#' @param object \code{scNMFSet} object containing count matrix.
#' @param ranks Rank for factorization; can be a vector of multiple values.
#' @param nrun No. of runs with different initial guesses.
#' @param verbose The verbosity level: 
#'        3, each iteration output printed;
#'        2, each run output printed; 
#'        1, each randomized sample output printed;
#'        0, silent.
#' @param progress.bar Display progress bar with \code{verbose = 1} for 
#'       multiple runs.
#' @param initializer If \code{'random'}, randomized initial conditions; 
#'        \code{'svd2'} for singular value decomposed initial condition.
#' @param Itmax Maximum no. of iteration.
#' @param hyper.update Vector of four logicals, each indcating whether
#'        hyperparameters \code{c(aw, bw, ah, bh)} should be optimized.
#' @param gamma.a Gamma distribution shape parameter.
#' @param gamma.b Gamma distribution mean. These two parameters are used for 
#'        fixed hyperparameters with \code{hyper.update} elements \code{FALSE}.
#' @param Tol Tolerance for terminating iteration.
#' @param hyper.update.n0 Initial number of steps in which hyperparameters 
#'        are fixed.
#' @param hyper.update.dn Step intervals for hyperparameter updates.
#' @param connectivity If \code{TRUE}, connectivity and dispersion will
#'        be calculated after each run. Can be turned off to save memory.
#' @param fudge Small positive number used as lower bound for factor matrix 
#'        elements to avoid singularity. If \code{fudge = NULL} (default), 
#'        it will be replaced by \code{.Machine$double.eps}. 
#'        Can be set to 0 to skip 
#'        regularization.
#' @param ncores Number of processors (cores) to run. If \code{ncores > 1},
#'        parallelization is attempted.
#' @param useC  Use C++ version of updates for speed.
#' @param unif.stop Terminate if any of columns in basis matrix is uniform.
#' @return Object of class \code{scNMFSet} with factorization slots filled.
#' 
#' @details When run with multiple values of \code{ranks}, factorization is 
#'        repeated for each rank and the slot \code{measure} contains 
#'        log evidence and optimal hyperparameters for each rank. 
#'        With \code{nrun > 1}, the solution
#'        with the maximum log evidence is stored for a given rank.
#' @examples
#' set.seed(1)
#' x <- simulate_whx(nrow=50,ncol=100,rank=5)
#' s <- scNMFSet(x$x)
#' s <- vb_factorize(s,ranks=seq(2,8),nrun=5)
#' plot(s)
#' @export
vb_factorize <- function(object, ranks=2, nrun=1, verbose=2, 
                         progress.bar=TRUE, initializer='random',
                         Itmax=10000, hyper.update=rep(TRUE,4), 
                         gamma.a=1, gamma.b=1, Tol=1e-5, 
                         hyper.update.n0=10, hyper.update.dn=1, 
                         connectivity=TRUE, fudge=NULL,
                         ncores=1, useC=TRUE,
                         unif.stop=TRUE){
  
   if(is.null(fudge)) fudge <- .Machine$double.eps
   mat <- counts(object) # S4 class scNMFSet
   
   if(initializer %in% c('svd','svd2') & nrun > 1)
     stop('SVD initializer does not require nrun > 1')
  
   nullr <- sum(Matrix::rowSums(mat)==0)
   nullc <- sum(Matrix::colSums(mat)==0)
   if(nullr>0) stop('Input matrix contains empty rows')
   if(nullc>0) stop('Input matrix contains empty columns')
   
   ranks <- ranks[ranks <= ncol(mat)] # rank <= no. of columns
   nrank <- length(ranks)
   
   bundle <- list(mat=mat, ranks=ranks, verbose=verbose, gamma.a=gamma.a,
                  gamma.b=gamma.b, initializer=initializer, 
                  connectivity=connectivity, 
                  Itmax=Itmax, fudge=fudge, useC=useC,
                  hyper.update=hyper.update, 
                  hyper.update.n0=hyper.update.n0, 
                  ncores=ncores, hyper.update.dn=hyper.update.dn, Tol=Tol,
                  unif.stop=unif.stop, nrun=nrun)
   if(ncores==1)
     vb <- lapply(seq_len(nrun), FUN=vb_iterate, bundle)
   else    # parallel
     vb <- Rmpi::mpi.applyLB(seq_len(nrun), FUN=vb_iterate, bundle)

   basis <- dbasis <- coeff <- dcoeff <- vector('list',nrank)
   rdat <- awdat <- bwdat <- ahdat <- bhdat <- nunif <- c()
   ranks2 <- c()
   for(k in seq_len(nrank)){     # find maximum solutions for each rank
     rmax <- -Inf
     for(i in seq_len(nrun)){
       if(vb[[i]]$rdat[k] > rmax){
         imax <- i
         rmax <- vb[[i]]$rdat[k]
       }
     }
     if(rmax==-Inf) next
     ranks2 <- c(ranks2,ranks[k])
     rdat <- c(rdat,rmax)
     basis[[k]] <- vb[[imax]]$wdat[[k]]
     coeff[[k]] <- vb[[imax]]$hdat[[k]]
     dbasis[[k]] <- vb[[imax]]$dwdat[[k]]
     dcoeff[[k]] <- vb[[imax]]$dhdat[[k]]
     awdat <- c(awdat, vb[[imax]]$hyperp[[k]]$aw)
     bwdat <- c(bwdat, vb[[imax]]$hyperp[[k]]$bw)
     ahdat <- c(ahdat, vb[[imax]]$hyperp[[k]]$ah)
     bhdat <- c(bhdat, vb[[imax]]$hyperp[[k]]$bh)
     nunif <- c(nunif, vb[[imax]]$nunif[k])
     
     rownames(basis[[k]]) <- rownames(dbasis[[k]]) <- rownames(mat)
     colnames(coeff[[k]]) <- colnames(dcoeff[[k]]) <- colnames(mat)
   }
   
   object@ranks <- ranks2
   object@basis <- basis
   object@dbasis <- dbasis
   object@coeff <- coeff
   object@dcoeff <- dcoeff
   object@measure <- data.frame(rank=ranks2, lml=rdat, aw=awdat, bw=bwdat, 
                                ah=ahdat, bh=bhdat, nunif=nunif)
   return(object)
}

vb_iterate <- function(irun, bundle){
  
   nrow <- dim(bundle$mat)[1]
   ncol <- dim(bundle$mat)[2]
   nrank <- length(bundle$ranks)
   
   rdat <- rep(-Inf, nrank)
   wdat <- hdat <- dwdat <- dhdat <- hyperp <- list()
   nunif <- rep(0, nrank)
   
   if(bundle$verbose >= 2) if(bundle$nrun > 1) 
     cat('Run ',irun,'\n',sep='')
   
   for(irank in seq_len(nrank)){
     
     rank <- bundle$ranks[[irank]]
     if(rank > min(nrow,ncol))
       stop('Rank exceeded min(nrow,ncol)')
     aw <- bundle$gamma.a[1]
     ah <- bundle$gamma.a[length(bundle$gamma.a)]
     bw <- bundle$gamma.b[1]
     bh <- bundle$gamma.b[length(bundle$gamma.b)]
     
     hyper <- hyper0 <- list(aw=aw, bw=bw, ah=ah, bh=bh)
       
     if(bundle$connectivity){
       npair <- ncol*(ncol-1)/2
       conav <- rep(0, npair)
     }

     hyper <- hyper0
     wh <- vb_init(nrow, ncol, bundle$mat, rank, hyper=hyper, 
                   initializer=bundle$initializer)
     lk0 <- 0
     for(it in seq_len(bundle$Itmax)){
       if(bundle$useC)
         wh <- vbnmf_update(as.matrix(bundle$mat),wh,hyper,c(bundle$fudge))
       else
         wh <- vbnmf_updateR(bundle$mat, wh, rank, hyper, fudge=bundle$fudge)
       if(it > bundle$hyper.update.n0 & it%%bundle$hyper.update.dn==0) 
         hyper <- hyper_update(bundle$hyper.update, wh, hyper, Niter=100, 
                            Tol=1e-3)
       if(is.na(wh$lkh)) break
       if(it>1) if(it > bundle$hyper.update.n0)
          if(wh$lkh>=lk0) if(abs(1-wh$lkh/lk0) < bundle$Tol) break
       lk0 <- wh$lkh
       if(bundle$verbose >= 3) cat(it,', log(evidence) = ',lk0,', aw = ',
                     hyper$aw,', bw = ',hyper$bw,', ah = ',hyper$ah,
                     ', bh = ',hyper$bh, '\n',sep='')
     }
     if(bundle$connectivity){
       cnn <- connectivity(wh$eh)
       conav <- conav + cnn
       disp <- dispersion(conav/irun,ncol)
     }
     if(bundle$verbose >= 2){
       if(bundle$connectivity) cat('Rank = ',rank,
                                    ': Nsteps =',it,', log(evidence) =',lk0,
                         ', hyper = (',hyper$aw,',',hyper$bw,',',hyper$ah,',',
                         hyper$bh,')', ', dispersion = ',disp,'\n',sep='')
       else cat('Rank = ',rank, ': Nsteps =',it,', log(evidence) =',lk0,
             ', hyper = (',hyper$aw,',',hyper$bw,',',hyper$ah,',',
             hyper$bh,')\n',sep='')
     }
     
     contains.unif <- apply(wh$ew,2,
                              function(x){abs(max(x)-min(x))<bundle$Tol})
     if(sum(contains.unif)>0){
       warning('Rank ',rank,' row/column ',
              paste(which(contains.unif),collapse=','),' constant.')
       if(bundle$unif.stop){
         warning('Rank scan stopped for rank >= ',rank)
         if(irank==1) stop('Rerun with lower ranks')
         break
       }
     }
     rdat[irank] <- lk0
     wdat[[irank]] <- wh$ew
     hdat[[irank]] <- wh$eh
     dwdat[[irank]] <- sqrt(wh$dw)
     dhdat[[irank]] <- sqrt(wh$dh) 
     hyperp[[irank]] <- hyper
   }   # end of irank-loop
   
   vb <- list(rdat=rdat, wdat=wdat, hdat=hdat, hyperp=hyperp, nunif=nunif,
              dwdat=dwdat,dhdat=dhdat)
   return(vb)
}

#' Class \code{scNMFSet} for storing input data and results
#'
#' \code{S4} class derived from \code{\link{SingleCellExperiment}}
#' that can store single-cell count matrix, gene and cell annotation 
#' data frames, and factorization factors as well as quality measures 
#' for rank determination.
#' 
#' @slot assays Named list for count matrix \code{counts}. 
#' @slot rowData \code{DataFrame} for gene (feature) 
#'    names and annotations in columns.
#' @slot colData \code{DataFrame} for cell IDs and other 
#'    annotations in columns (e.g., barcodes, cell types).
#' @slot ranks Vector for rank values for which factorization has been 
#'   performed.
#' @slot basis List (of length equal to that of \code{ranks}) of 
#'   basis matrices \strong{W} from factorization; 
#'   dimension \code{nrow} x \code{rank},
#'       where \code{nrow} is no. of rows in \code{count}.
#' @slot coeff List (of length equal to that of \code{ranks}) of 
#'  coefficient matrices \strong{H} from factorization; 
#'       dimension \code{rank} x \code{ncol},
#'       where \code{ncol} is no. of columns in \code{count}.
#' @slot measure Data frame of factorization quality measures for 
#'   each rank (\code{likelihood} and \code{dispersion}).
#' 
#' Other slots inherited from \code{SingleCellExperiment} class are 
#' not explicitly used.
#' 
#' @examples
#' library(S4Vectors)
#' # toy matrix
#' ngenes <- 8 
#' ncells <- 5
#' mat <- matrix(rpois(n=ngenes*ncells,lambda=3),ngenes,ncells)
#' 
#' abc <- letters[seq_len(ngenes)]
#' ABC <- LETTERS[seq_len(ncells)] 
#' genes <- DataFrame(gene_id=abc)
#' cells <- DataFrame(cell_id=ABC)
#' rownames(mat) <- rownames(genes) <- abc
#' colnames(mat) <- rownames(cells) <- ABC
#' 
#' # create scNMFSet object
#' s <- scNMFSet(count=mat,rowData=genes,colData=cells)
#' # alternative ways
#' s2 <- scNMFSet(count=mat)
#' s2 <- scNMFSet(assays=list(counts=mat))        
#'
#' # show dimensions
#' dim(s)
#' 
#' # show slots
#' rowData(s)
#' 
#' # modify slots
#' colData(s) <- DataFrame(cell_id=seq_len(ncells),
#'               cell_type=c(rep('tissue1',2),
#'                           rep('tissue2',ncells-2)))
#' colData(s)
#' @return Object of class \code{scNMFSet}
#' @export scNMFSet
#' @import SingleCellExperiment
#' @import S4Vectors
#' @import methods
#' @importFrom Rdpack reprompt
setClass('scNMFSet',
         slots=c(ranks='vector',
                 basis='list', dbasis='list',
                 coeff='list', dcoeff='list',
                 measure='data.frame'),
         contains='SingleCellExperiment')

#' Create \code{scNMFSet} object
#'
#' Object derived from \code{\link{SingleCellExperiment}}
#' 
#' @param count Count matrix
#' @param ... Other parameters of \code{\link{SingleCellExperiment}}
#' @param remove.zeros Remove empty rows and columns
#' @return Object of class \code{scNMFSet}.
#' @examples
#' count <- matrix(rpois(n=12,lambda=2),4,3)
#' s <- scNMFSet(count=count)
#' s
#' @export
scNMFSet <- function(count=NULL, ..., remove.zeros=TRUE){
           if(!is.null(count))
             Object <- SingleCellExperiment(assays=list(counts=count), ...)
           else
             Object <- SingleCellExperiment(...)
           if(min(counts(Object))<0) 
             stop('Count data contains negative values.')
           if(remove.zeros) Object <- remove_zeros(Object)
           x <- new('scNMFSet', Object)
           return(x)
}

#' Display object
#' 
#' Display the class and dimension of an object
#'  
#' Object name itself on command line or \code{(show(object))} will display 
#' class and dimensionality
#' 
#' @param object Object of class \code{scNMFSet}
#' @return \code{NULL}
#' @examples
#' s <- scNMFSet(matrix(rpois(n=12,lambda=3),4,3))
#' show(s)
#' @export
setMethod('show', signature='scNMFSet',
           definition=function(object){
             cat('class:', class(object),'\n')
             cat('dim:', dim(object),'\n')
             cat('rownames: ')
             print(utils::head(rownames(object)))
             cat('colnames: ')
             print(utils::head(colnames(object)))
          })

#' Accessor for count matrix
#' 
#' @param object Object containing count matrix
#' @return Count matrix
#' @examples
#' s <- scNMFSet(count = matrix(rpois(n=12,lambda=3),3,4))
#' counts(s)
#' 
#' @export
setMethod('counts',signature='scNMFSet',
     function(object){
       assay(object, i='counts')
     }
)
#' Assignment of count matrix
#' 
#' Count matrix can be modified
#' 
#' @param object Object containing count
#' @param value Matrix-like object for replacement
#' @return Object with updated count
#' @export
#' @examples
#' mat <- matrix(rpois(n=12,lambda=3),3,4)
#' s <- scNMFSet(count = mat)
#' counts(s) <- mat^2
#' counts(s)
setMethod('counts<-','scNMFSet',
     function(object,value){
       assay(object, i='counts') <- value
       object
     }
)
#' Rank values in an Object
#' 
#' Retrieve or set the rank values in an object
#' 
#' Ranks for which factorization has been performed are stored 
#' in slot \code{ranks} of \code{scNMFSet} object.
#' \code{ranks(object)} will return the rank vector. 
#' \code{ranks(object) <- value}
#' can be used to modify it.
#' @param object Object of class \code{scNMFSet}.
#' @return Either \code{NULL} or vector.
#' @examples
#' s <- scNMFSet(matrix(rpois(n=12,lambda=3),4,3))
#' s <- vb_factorize(s,ranks=seq(2,4))
#' ranks(s)
#' @export
setGeneric('ranks', function(object) standardGeneric('ranks'))
#' Rank accessor
#' @param object Object containing rank values
#' @return Vector of rank values
setMethod('ranks', signature='scNMFSet', function(object) object@ranks)

#' Basis matrices in an Object
#' 
#' Retrieve or set the basis matrices \code{W} from factorization 
#' in an object
#' 
#' After factorization, basis matrices corresponding to each rank value are
#' stored as elements of a list, which is in slot \code{basis} of object of
#' class \code{scNMFSet}.
#' \code{basis(object)} will return the list of matrices. 
#' \code{basis(object) <- value}
#' can be used to modify it.
#' @param object Object of class \code{scNMFSet}
#' @return Either \code{NULL} or a list of same length as 
#' \code{ranks(object)}, whose
#' elements are basis matrices derived from factorization 
#' under each rank value.
#' @examples
#' s <- scNMFSet(count=matrix(rpois(n=12,lambda=3),4,3))
#' s <- vb_factorize(s,ranks=seq(2,4))
#' basis(s)[[1]]
#' @export
setGeneric('basis', function(object) standardGeneric('basis'))

#' Basis matrix accessor
#' 
#' @param object Object containing basis matrix
#' @return List of basis matrices
setMethod('basis', signature='scNMFSet', function(object) object@basis)

#' Basis SD matrix accessor
#' 
#' @param object Object containing dbasis matrix
#' @return List of dbasis matrices
#' @export
setGeneric('dbasis', function(object) standardGeneric('dbasis'))
#' Basis SD matrix accessor
#' 
#' @param object Object containing basis standard deviation (SD) matrix
#' @return List of dbasis matrices
setMethod('dbasis', signature='scNMFSet', function(object) object@dbasis)

#' Coefficient matrices in an Object
#' 
#' Retrieve or set the coefficient matrices from factorization in an 
#' object
#' 
#' After factorization, coefficient matrices \code{H} corresponding 
#' to each rank value are
#' stored as elements of a list, which is in slot \code{coeff} of object of
#' class \code{scNMFSet}.
#' \code{coeff(object)} will return the list of matrices. 
#' \code{coeff(object) <- value}
#' can be used to modify it.
#' @param object Object of class \code{scNMFSet}.
#' @return Either \code{NULL} or a list of same length as 
#' \code{ranks(object)}, whose
#' elements are coefficient matrices derived from factorization 
#' under each rank value.
#' @examples
#' s <- scNMFSet(count=matrix(rpois(n=12,lambda=3),4,3))
#' s <- vb_factorize(s,ranks=seq(2,4))
#' coeff(s)[[1]]
#' @export
setGeneric('coeff', function(object) standardGeneric('coeff'))
#' Coefficient matrix accessor
#' 
#' @param object Object containing coefficient matrix
#' @return List of coefficient matrices
setMethod('coeff', signature='scNMFSet', function(object) object@coeff)

#' Coeff SD matrix accessor
#' 
#' @param object Object containing dcoeff matrix
#' @return List of dcoeff matrices
#' @export
setGeneric('dcoeff', function(object) standardGeneric('dcoeff'))

#' Coeffcient SD matrix accessor
#' 
#' @param object Object containing coeffient standard deviation (SD) matrix
#' @return List of dcoeff matrices
setMethod('dcoeff', signature='scNMFSet', function(object) object@dcoeff)

#' Factorization measures in an Object
#' 
#' Retrieve or set factorization measures in an object
#' 
#' Factorization under multiple rank values lead to measures stored in
#' a data frame inside a slot \code{measure}. In maximum likelihood using
#' \code{\link{factorize}}, this set of quality measures include 
#' dispersion and cophenetic
#' coeeficients for each rank. In Bayesian factorization using 
#' \code{\link{vb_factorize}},
#' log evidence for each rank is stored. \code{measure(object)} 
#' will return the data
#' frame. \code{measure(object) <- value}
#' can be used to modify it.
#' @param object Object of class \code{scNMFSet}.
#' @return Either \code{NULL} or a data frame containing measures.
#' @examples
#' s <- scNMFSet(count=matrix(rpois(n=12,lambda=3),4,3))
#' s <- vb_factorize(s,ranks=seq(2,4))
#' measure(s)
#' @export
setGeneric('measure', function(object) standardGeneric('measure'))
#' Rank measure accessor
#' 
#' @param object Object containing measure
#' @return Data frame of measure
setMethod('measure', signature='scNMFSet', function(object) object@measure)

#' Subsetting scNMFSet object
# 
# @name [
#' @aliases [,scNMFSet-method
#' @docType methods
#' @rdname subset-methods
#' @param x Object to be subsetted
#' @param i row index
#' @param j column index
#' @return Subsetted object
setMethod('[', 'scNMFSet', function(x, i, j){
              if(missing(i)) i=seq_len(nrow(x))
              if(missing(j)) j=seq_len(ncol(x))
              x <- callNextMethod()
              if(length(basis(x)) > 0){
                w <- basis(x)
                dw <- dbasis(x)
                for(k in seq_len(length(w))){ 
                  w[[k]] <- w[[k]][i,]
                  dw[[k]] <- dw[[k]][i,]
                }
                basis(x) <- w
                dbasis(x) <- dw
              }
              if(length(coeff(x)) > 0){
                h <- coeff(x)
                dh <- dcoeff(x)
                for(k in seq_len(length(h))){
                  h[[k]] <- h[[k]][,j]
                  dh[[k]] <- dh[[k]][,j]
                }
                coeff(x) <- h
                dcoeff(x) <- dh
              }
              return(x)
          })

setValidity('scNMFSet', function(object){
    valid <- TRUE
    if(length(ranks(object))!=length(basis(object)) |
       length(ranks(object))!=length(coeff(object)) |
       length(basis(object))!=length(coeff(object))){
         valid <- FALSE
         msg <- 'rank, basis, or coeff data length do not match.'
    }
    if(valid) TRUE else msg
})

#' Feature annotation accessor
#' 
#' @param x Object containing data
#' @return DataFrame of feature annotation
#' @examples
#' x <- matrix(rpois(n=12,lambda=3),4,3)
#' rownames(x) <- seq_len(4)
#' colnames(x) <- seq_len(3)
#' s <- scNMFSet(count=x,rowData=seq_len(4),colData=seq_len(3))
#' rowData(s) 
#' @export
setMethod('rowData','scNMFSet', 
          function(x){
            callNextMethod()})
#' Gene annotation assignment
#' 
#' @param x Object containing data
#' @param value DataFrame of row annotation to be substituted
#' @return Row annotation DataFrame
#' @export
#' @import SummarizedExperiment
setMethod('rowData<-','scNMFSet', 
          function(x, value){
            callNextMethod()})

#' Sample annotation accessor
#' 
#' @param x Object containing sample annotation
#' @return Column annotation DataFrame 
#' @examples
#' library(S4Vectors)
#' x <- matrix(rpois(n=12,lambda=3),4,3)
#' rownames(x) <- seq_len(4)
#' colnames(x) <- c('a','b','c')
#' s <- scNMFSet(count=x,rowData=seq_len(4),colData=c('a','b','c'))
#' cols <- DataFrame(tissue=c('tissue1','tissue1','tissue2'))
#' rownames(cols) <- c('a','b','c')
#' colData(s) <- cols
#' s
#' @export
setMethod('colData','scNMFSet',
          function(x){callNextMethod()})

#' Cell annotation assignment
#' 
#' @param x Object containing cell annotation
#' @param value DataFrame to be substituted
#' @return Updated column annotation 
#' @examples
#' library(S4Vectors)
#' x <- matrix(rpois(n=12,lambda=3),4,3)
#' rownames(x) <- seq_len(4)
#' colnames(x) <- c('a','b','c')
#' s <- scNMFSet(count=x,rowData=seq_len(4),colData=c('a','b','c'))
#' cols <- DataFrame(tissue=c('tissue1','tissue1','tissue2'))
#' rownames(cols) <- c('a','b','c')
#' colData(s) <- cols
#' s
#' @export
setMethod('colData<-','scNMFSet', 
          function(x, value){
            callNextMethod()})

#' Generics for ranks assignment
#'
#' Replace \code{ranks} slot of \code{scNMFSet} object
#' 
#' @param object Object of class \code{scNMFSet}
#' @param value Rank values (vector) to be substituted
#' @return Input object with updated ranks
#' @examples
#' s <- scNMFSet(count=matrix(rpois(n=12,lambda=3),4,3))
#' s <- vb_factorize(s, ranks=seq(2,3))
#' ranks(s) <- c('two','three')
#' ranks(s)
#' @export
setGeneric('ranks<-', function(object,value) standardGeneric('ranks<-'))
#' Modify ranks
#'
#' Replace \code{ranks} slot of \code{scNMFSet} object
#' 
#' @param object Object of class \code{scNMFSet}
#' @param value Rank values (vector) to be substituted
#' @return Input object with updated ranks
#' @examples
#' s <- scNMFSet(count=matrix(rpois(n=12,lambda=3),4,3))
#' s <- vb_factorize(s, ranks=seq(2,3))
#' ranks(s) <- c('two','three')
#' ranks(s)
#' @export
setMethod('ranks<-','scNMFSet',
       function(object, value){
         object@ranks <- value
         if(validObject(object)) return(object)
})

#' Generics for basis matrix assignment
#'
#' Access and modify basis matrices 
#' 
#' @param object Object of class \code{scNMFSet}
#' @param value Basis matrix to be substituted
#' @return Input object with updated basis matrices
#' @examples
#' set.seed(1)
#' s <- scNMFSet(count=matrix(rpois(n=12,lambda=3),4,3))
#' s <- vb_factorize(s, ranks=3)
#' basis(s)[[1]] <- apply(basis(s)[[1]],seq(1,2),round,digits=3)
#' basis(s)
#' @export
setGeneric('basis<-', function(object,value) standardGeneric('basis<-'))
#' Modify basis matrices
#'
#' Access and modify basis matrices 
#' 
#' @param object Object of class \code{scNMFSet}
#' @param value Basis matrix to be substituted
#' @return Input object with updated basis matrices
#' @examples
#' set.seed(1)
#' s <- scNMFSet(count=matrix(rpois(n=12,lambda=3),4,3))
#' s <- vb_factorize(s, ranks=3)
#' basis(s)[[1]] <- apply(basis(s)[[1]],c(1,2),round,digits=3)
#' basis(s)
#' @export
setMethod('basis<-','scNMFSet',
       function(object, value){
         object@basis <- value
#        if(validObject(object)) return(object)
         return(object)
         })
#' Basis SD matrix assignment
#' 
#' @param object Object containing dbasis matrix
#' @param value List for assignment
#' @return Updated object
#' @export
setGeneric('dbasis<-', function(object,value) standardGeneric('dbasis<-'))
#' Modify dbasis matrices
#'
#' Access and modify dbasis matrices 
#' 
#' @param object Object of class \code{scNMFSet}
#' @param value Basis SD matrix to be substituted
#' @return Modified object
setMethod('dbasis<-','scNMFSet',
          function(object, value){
            object@dbasis <- value
            return(object)
          })

#' Generics for coefficient matrix assignment
#'
#' Access and modify coefficient matrices 
#' 
#' @param object Object of class \code{scNMFSet}
#' @param value Coefficient matrix to be substituted
#' @return Input object with updated coefficient matrices
#' @examples
#' s <- scNMFSet(count=matrix(rpois(n=12,lambda=3),4,3))
#' s <- vb_factorize(s, ranks=3)
#' coeff(s)[[1]] <- apply(coeff(s)[[1]],c(1,2),round,digits=2)
#' coeff(s)
#' @export
setGeneric('coeff<-', function(object,value) standardGeneric('coeff<-'))
#' Modify coefficient matrices
#'
#' Can be used to access and modify coefficient matrices 
#' 
#' @param object Object of class \code{scNMFSet}
#' @param value Coefficient matrix to be substituted
#' @return Input object with updated coefficient matrices
#' @examples
#' s <- scNMFSet(count=matrix(rpois(n=12,lambda=3),4,3))
#' s <- vb_factorize(s, ranks=3)
#' coeff(s)[[1]] <- apply(coeff(s)[[1]],c(1,2),round,digits=2)
#' coeff(s)
#' @export
setMethod('coeff<-','scNMFSet',
       function(object, value){
         object@coeff<- value
#        if(validObject(object)) return(object)
         return(object)
})
#' Coeff SD matrix assignment
#' 
#' @param object Object containing dcoeff matrix
#' @param value List for assignment
#' @return Updated object
setGeneric('dcoeff<-', function(object,value) standardGeneric('dcoeff<-'))
#' Modify dcoeff matrices
#'
#' Access and modify dcoeff matrices 
#' 
#' @param object Object of class \code{scNMFSet}
#' @param value Coeff SD matrix to be substituted
#' @return Updated object
setMethod('dcoeff<-','scNMFSet',
          function(object, value){
            object@dcoeff <- value
            return(object)
          })

#' Generics for factorization measure assignment
#'
#' Can be used to access and modify factorization measure
#' 
#' @param object Object of class \code{scNMFSet}
#' @param value Measure to be substituted
#' @examples
#' s <- scNMFSet(count=matrix(rpois(n=12,lambda=3),4,3))
#' s <- vb_factorize(s, ranks=3)
#' measure(s)[,-1] <- apply(measure(s)[,-1], c(1,2), round,digits=3)
#' measure(s)
#' @return Input object with updated measure
#' @export
setGeneric('measure<-', function(object,value) standardGeneric('measure<-'))
#' Modify factorization measure
#'
#' Can be used to access and modify factorization measure
#' 
#' @param object Object of class \code{scNMFSet}
#' @param value Measure to be substituted
#' @examples
#' s <- scNMFSet(count=matrix(rpois(n=12,lambda=3),4,3))
#' s <- vb_factorize(s, ranks=3)
#' measure(s)[,-1] <- apply(measure(s)[,-1], c(1,2), round,digits=3)
#' measure(s)
#' @return Input object with updated measure
#' @export
setMethod('measure<-','scNMFSet',
       function(object, value){
         object@measure<- value
         if(validObject(object)) return(object)
})


#' @describeIn scNMFSet Plot measures of an object. 
#' For quality measures derived from maximum likelihood inference, 
#' dispersion and cophenetic will be plotted separately.
#' 
#' For measure derived from Bayesian inference, log evidence as a function of 
#' rank values will be plotted. 
#' 
#' @param x Object containing measure
#' @return \code{NULL}
#' @export
#' @importFrom graphics plot
setMethod('plot',signature="scNMFSet",definition = 
            function(x){
    
     bayes <- names(x@measure)[2] %in% c('lml','E','evidence')   
     dflag <- FALSE
     mx <- x@measure
     if(bayes) ylab <- c('log ML')
     else ylab <- c('Likelihood','Dispersion', 'Cophenetic')
     
     if(sum(dim(mx))==0) stop('Quality measure empty.')
    
     if(bayes){
       graphics::plot(NULL,xlim=c(mx$rank[1],mx$rank[nrow(mx)]),
                      ylim=c(min(mx[,2]),max(mx[,2])),xlab='Rank', 
                      ylab=ylab, bty='n')
       graphics::points(x=mx$rank, y=mx[,2], type='b',xlab='Rank', 
                      ylab=ylab, bty='n',pch=21,bg='white')
     }
     else{   
       par(mfrow=c(1,3))
       graphics::plot("",xlim=c(mx$rank[1], mx$rank[length(mx$rank)]),
          ylim=c(min(mx$likelihood),max(mx$likelihood)), xlab='Rank',
          ylab=ylab[1], bty='n')
       graphics::points(x=mx$rank,y=mx$likelihood,pch=21,
                        bg='white',type='b')
     
       graphics::plot("",xlim=c(mx$rank[1], mx$rank[length(mx$rank)]),
          ylim=c(min(mx$dispersion),max(mx$dispersion)), xlab='Rank',
          ylab=ylab[2], bty='n')
       graphics::points(x=mx$rank,y=mx$dispersion,pch=21,bg='white',
                        type='b')
     
       plot("",xlim=c(mx$rank[1], mx$rank[length(mx$rank)]),
          ylim=c(min(mx$cophenetic),max(mx$cophenetic)), xlab='Rank',
          ylab=ylab[3], bty='n')
       graphics::points(x=mx$rank, y=mx$cophenetic, pch=21,bg='white',
                        type='b')
     }
            
     return(invisible())
})

#' Remove rows or columns that are empty from an object
#'
#' @param object Object containing data
#' @return Object with empty rows/columns removed
#' @examples
#' set.seed(1)
#' x <- matrix(rpois(n=100,lambda=0.1),10,10)
#' s <- scNMFSet(count=x,remove.zeros=FALSE)
#' s2 <- remove_zeros(s)
#' s2
#' @export
remove_zeros <- function(object){

  if(is(object,'matrix'))
    count <- object
  else
    count <- counts(object)

  gene0 <- Matrix::rowSums(count)==0
  cell0 <- Matrix::colSums(count)==0
  ng0 <- sum(gene0)
  nc0 <- sum(cell0)
  
  if(ng0+nc0>0){
    object <- object[!gene0,!cell0]
    if(ng0>0)
      cat(ng0,'empty rows removed\n')
    if(nc0>0)
        cat(nc0,'empty cells removed\n')
  }
  object
}

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

vbnmf_update <- function(X, wh, hyper, fudge) {
    .Call(`_ccfindR_vbnmf_update`, X, wh, hyper, fudge)
}

#' ccfindR: Cancer Clone FindeR
#' 
#' This package contains tools and utilities for cell-type discovery
#' using single-cell transcriptomic data while evaluating significance
#' of the depth of clustering \insertCite{woo_etal}{ccfindR}.
#' @references
#' \insertRef{woo_etal}{ccfindR}
#' 
#' @docType package
#' @name ccfindR
NULL  

---
title: "ccfindR: single-cell RNA-seq analysis using Bayesian non-negative matrix factorization"
author: 
- name: Jun Woo
  affiliation: Institute for Health Informatics, University of Minnesota
- name: Constantin Aliferis
  affiliation: Institute for Health Informatics, University of Minnesota
- name: Jinhua Wang
  affiliation: Institute for Health Informatics, University of Minnesota
package: ccfindR
date: "`r Sys.Date()`"
output:
  BiocStyle::html_document:
    fig_caption: true
    toc_float: true
bibliography: scRNA.bib
csl: nature.csl
vignette: >
  %\VignetteIndexEntry{ccfindR: single-cell RNA-seq analysis using Bayesian non-negative matrix factorization}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

The `ccfindR` (Cancer Clone findeR) package [@woo_etal] contains 
implementations and utilities for analyzing single-cell 
RNA-sequencing data, including quality control, 
unsupervised clustering for discovery of cell types, 
and visualization of the outcomes. It is especially 
suitable for analysis of transcript-count data utilizing 
unique molecular identifiers (UMIs), e.g., data derived 
from 10x Genomics platform. In these data sets, RNA counts 
are non-negative integers, enabling clustering using non-negative 
matrix factorization (NMF) [@lee_seung].

Input data are UMI counts in the form of a matrix with each genetic
feature ("genes") in rows and cells (tagged by barcodes) in columns, 
produced by read alignment and counting pipelines. The count matrix and
associated gene and cell annotation files are bundled into a main 
object of class `scNMFSet`, which extends the
`SingleCellExperiment` class [http://dx.doi.org/10.18129/B9.bioc.SingleCellExperiment)].
Quality control for both cells and genes can be performed via filtering
steps based on UMI counts and variance of expressions, respectively. 
The NMF factorization is first performed for multiple values of 
ranks (the reduced dimension of factorization) to find the most 
likely value. A production run for the chosen rank then leads to 
factor matrices, allowing the user to identify and visualize genes 
representative of clusters and assign cells into clusters.

# Algorithm

The NMF approach offers a means to identify cell subtypes and classify 
individual cells into these clusters based on clustering using 
expression counts. In contrast to alternatives such as principal 
component analyses [@hastie_etal], NMF leverages the non-negative nature 
of count data and factorizes the data matrix $\sf X$ into two 
factor matrices 
$\sf W$ and $\sf H$ [@lee_seung]:

\begin{equation}
\sf{X} \sim {\sf W}{\sf H}.
\end{equation}

If $\sf X$ is a $p\times n$ matrix ($p$ genes and $n$ cells), 
the basis matrix $\sf W$ is $p \times r$ and coefficient matrix 
$\sf H$ is $r \times n$ in dimension, respectively, where the rank $r$ is 
a relatively small integer.
A statistical inference-based interpretation of NMF is to view $X_{ij}$ as 
a realization of a Poisson distribution with the mean for each matrix
element given by $({\sf WH})_{ij}\equiv \Lambda_{ij}$, or

\begin{equation}
\Pr(x_{ij})=\frac{e^{-\Lambda_{ij}}{\Lambda_{ij}}^{x_{ij}}}
{\Gamma(1+x_{ij})}.
\end{equation}

The maximum likelihood inference of the latter is then achieved by 
maximizing

\begin{equation}
L = \sum_{ij} \left(X_{ij} \ln \frac{\Lambda_{ij}}{X_{ij}}-
  \Lambda_{ij}+X_{ij}\right).
\end{equation}

The Kullback-Leibler measure of the distance between $\sf X$ and 
$\sf \Lambda$,
which is minimized, is equal to $-L$.
Lee and Seung's update rule [@lee_seung] solves this optimization task 
iteratively. 

While also including this classical iterative update 
algorithm to find basis and coefficient factors of the count matrix, the
main workhorse in `ccfindR` is the variational Bayesian inference 
algorithm proposed by Cemgil [@cemgil]. Thus the key distinguishing 
features of `ccfindR` [@woo_etal] compared to other existing implementations -- `NMF` for generic data 
[@gaujoux_seoighe] and `NMFEM` for single-cell analysis [@zhu_etal] --
are

* Bayesian inference allowing for a statistically well-controlled procedure 
to determine the most likely value of rank $r$.
* Procedure to derive hierarchical relationships among clusters
identified under different ranks.

In particular, a traditional way (in maximum likelihood inference) 
to determine the rank is to evaluate the 
factorization quality measures (and optionally compare with those from 
randomized data). The Bayesian formulation of NMF algorithm instead 
incorporates priors for factored matrix elements $\sf W$ and $\sf H$ 
modeled by gamma distributions. Inference can be combined with hyperparameter
update to optimize the marginal likelihood (ML; 
conditional probability of data under
hyperparameters and rank), which provides a statistically well-controlled
means to determine the optimal rank describing data.

For large rank values, it can be challenging to interpret clusters
identified. To facilitate biological interpretation, we provide a procedure 
where cluster assignment of cells is repeated for multiple
rank values, typically ranging from 2 to the optimal rank, and a phylogenetic 
tree connecting different clusters at neighboring rank 
values are constructed. This tree gives an overview of different types of
cells present in the system viewed at varying resolution.

# Workflow

We illustrate a typical workflow with a single-cell count data set
generated from peripheral blood mononuclear cell (PBMC) 
data [https://support.10xgenomics.com/single-cell-gene-expression/datasets/1.1.0/].
The particular data set used below was created by sampling from five 
purified immune cell subsets.

## Installation
To install the package, do the following: 
```{r,eval=FALSE}
BiocManager::install('ccfindR')
```
After installation, load the package by
```{R}
library(ccfindR)
```

## Data input

The input data can be a simple matrix:
```{r, echo=T}
# A toy matrix for count data
set.seed(1)
mat <- matrix(rpois(n = 80, lambda = 2), nrow = 4, ncol = 20)
ABC <- LETTERS[1:4]
abc <- letters[1:20]
rownames(mat) <- ABC
colnames(mat) <- abc
```

The main `S4` object containing data and subsequent analysis outcomes is of 
class `scNMFSet`, created by
```{r, echo=T}
# create scNMFSet object
sc <- scNMFSet(count = mat)
```

This class extends `SingleCellExperiment`
[class](http://dx.doi.org/10.18129/B9.bioc.SingleCellExperiment), 
adding extra slots for storing factorization outcomes.
In particular, `assays`, `rowData`, and `colData` slots of
`SingleCellExperiment` class are used to store RNA count matrix, 
gene, and cell annotation data frames, respectively.
In the simplest initialization above, the named argument `count` is
used as the count matrix and is equivalent to
```{r, echo=T}
# create scNMFSet object
sc <- scNMFSet(assays = list(counts = mat))
```
See `SingleCellExperiment` documentations for more details of these
main slots. For instance, row and column names can be stored by
```{r}
# set row and column names
suppressMessages(library(S4Vectors))
genes <- DataFrame(ABC)
rownames(genes) <- ABC
cells <- DataFrame(abc)
rownames(cells) <- abc
sc <- scNMFSet(count = mat, rowData = genes, colData = cells)
sc
```

Alternatively, sparse matrix format (of class `dgCMatrix`) can be used. 
A `MatrixMarket` format file can be read directly:
```{r}
# read sparse matrix
dir <- system.file('extdata', package = 'ccfindR')
mat <- Matrix::readMM(paste0(dir,'/matrix.mtx'))
rownames(mat) <- 1:nrow(mat)
colnames(mat) <- 1:ncol(mat)
sc <- scNMFSet(count = mat, rowData = DataFrame(1:nrow(mat)),
               colData = DataFrame(1:ncol(mat)))
sc
```
The number of rows in `assays$counts` and `rowData`, the number of columns 
in `assays$counts` and rows in `colData` must match.

The gene and barcode meta-data and count files resulting from 10x Genomics'
Cell Ranger pipeline
(https://support.10xgenomics.com/single-cell-gene-expression/software/pipelines/latest/what-is-cell-ranger) can also be read:
```{r}
# read 10x files
sc <- read_10x(dir = dir, count = 'matrix.mtx', genes = 'genes.tsv',
               barcodes = 'barcodes.tsv')
sc
```

The parameter `dir` is the directory containing the files. 
Filenames above are the defaults and can be omitted.
The function returns an `scNMFSet` object. 
By default, any row or column entirely consisting of zeros in `counts` and the
corresponding elements in `rowData` and `colData` slots will be removed. 
This feature can be turned off by `remove.zeros = FALSE`.

## Quality control

For quality control, cells and genes can be filtered manually using normal
subsetting syntax of `R`: the slots in the object `sc` are accessed and 
edited using accessors and sub-setting rules;
see 
[`SingleCellExperiment`](http://dx.doi.org/10.18129/B9.bioc.SingleCellExperiment):
```{R}
# slots and subsetting
counts(sc)[1:7,1:3]
head(rowData(sc))
head(colData(sc))
sc2 <- sc[1:20,1:70]       # subsetting of object
sc2 <- remove_zeros(sc2)   # remove empty rows/columns
sc2
```

We provide two streamlined functions each for cell and gene filtering,
which are illustrated below:
```{r cells, cache=T, fig.small=TRUE,fig.cap="Quality control filtering of cells. Histogram of UMI counts is shown. Cells can be selected (red) by setting lower and upper thresholds of the UMI count."}
sc <- filter_cells(sc, umi.min = 10^2.6, umi.max = 10^3.4)
```

```{r genes, cache=T, fig.small=TRUE, fig.cap="Selection of genes for clustering. The scatter plot shows distributions of expression variance to mean ratio (VMR) and the number of cells expressed. Minimum VMR and a range of cell number can be set to select genes (red). Symbols in orange are marker genes provided as input, selected irrespective of expression variance."}
markers <- c('CD4','CD8A','CD8B','CD19','CD3G','CD3D',
             'CD3Z','CD14')
sc0 <- filter_genes(sc, markers = markers, vmr.min = 1.5, 
            min.cells.expressed = 50, rescue.genes = FALSE)
```

The function `filter_cells()` plots histogram of UMI counts for all cells 
when called without threshold parameters (Fig. \@ref(fig:cells)). 
This plot can be used 
to set desirable thresholds, `umi.min` and `umi.max`. Cells with UMI counts 
outside will be filtered out. The function `filter_genes()` displays 
scatter plot of the total number of cells with nonzero count and VMR 
(variance-to-mean ratio) for each gene (Fig. \@ref(fig:genes)). 
In both plots, selected 
cells and genes are shown in red. Note that the above example has thresholds 
that are too stringent, which is intended to speed up the subsequent 
illustrative runs.
A list of pre-selected marker genes can be provided to help identify
clusters via the `markers` parameter in `filter_genes()`. Here, we use a 
set of classical PBMC marker genes (shown in orange).

Gene-filtering can also be augmented by scanning for those genes whose count 
distributions among cells are non-trivial: most have zero count as its 
maximum; some have one or more distinct peaks at nonzero count values. 
These may signify the existence of groups of cells in which the genes 
are expressed in distinguishable fashion. The selection of genes by `filter_genes()` 
will be set as the union of threshold-based group and those with such 
nonzero-count modes by setting `rescue.genes = TRUE`:
```{r rescue, cache=T, echo=T, fig.small=TRUE, fig.cap='Additional selection of genes with modes at nonzero counts. Symbols in blue represent genes rescued.'}
sc_rescue <- filter_genes(sc, markers = markers, vmr.min = 1.5, min.cells.expressed = 50,
                          rescue.genes = TRUE, progress.bar = FALSE)
```

This "gene rescue" scan will take some time and a progress bar is 
displayed if `progress.bar = TRUE`.

For subsequent analysis, we will use the latter selection and also name 
rows with gene symbols:
```{r, cache=T}
rownames(sc_rescue) <- rowData(sc_rescue)[,2]
sc <- sc_rescue
```

## Rank determination

The main function for maximum likelihood NMF on a count matrix is 
`factorize()`. It performs a series of iterative updates to matrices 
$\sf W$ and $\sf H$. 
Since the global optimum of likelihood function is not directly accessible, 
computational inference relies on local maxima, which depends on initializations.
We adopt the randomized initialization scheme, where the factor matrix 
elements are drawn from uniform distributions. 
To make the inference reproducible, one can set the random number seed 
by `set.seed(seed)`,
where `seed` is a positive integer, prior to calling `factorize()`. Updates 
continue until convergence is reached, defined by either the fractional 
change in likelihood being smaller than `Tol` (`criterion = likelihood`)
or a set number (`ncnn.step`) of steps observed during which the 
connectivity matrix remains unchanged (`criterion = connectivity`).
The connectivity matrix $\sf C$ is a symmetric $n\times n$ matrix with 
elements $C_{jl}=1$ if $j$ and $l$ cells belong to the same cluster 
and $0$ otherwise. The cluster membership is dynamically checked by 
finding the row 
index $k$ for which the coefficient matrix element $H_{kj}$ is maximum 
for each cell indexed by $j$. 

During iteration, with `verbose = 3`, step number, log likelihood per
elements, and the number of terms in the upper-diagonal part of $\sf C$ 
that changed from the previous step are printed:
```{r, cache=T}
set.seed(1)
sc <- factorize(sc, ranks = 3, nrun = 1, ncnn.step = 1, 
                criterion='connectivity', verbose = 3)
```

The function `factorize()` returns the same object `sc` with extra slots
`ranks` (the rank value for which factorization was performed), `basis` 
(a list containing the basis matrix $\sf W$), `coeff` (a list containing 
the coefficient matrix $\sf H$), and `measure` (a data frame containing
the factorization quality measure; see below). The `criterion`
used to stop iteration is either `connectivity` (no changes to
connectivity matrix for `ncnn.steps`) or `likelihood` (changes
to likelihood smaller than `Tol`).

To reduce the dependence of final estimates for $\sf W$ and $\sf H$ on 
initial guess, inferences need to be repeated for many different initializations:
```{r, cache=T}
sc <- factorize(sc, ranks = 3, nrun = 5, verbose = 2)
```

After each run, the likelihood and dispersion are printed, and the global 
maximum of likelihood as well as the corresponding matrices $\sf W$ and 
$\sf H$ are stored. The dispersion $\rho$ is a scalar measure of how 
close the consistency matrix $\sf{\bar C}\equiv {\rm Mean}({\sf C})$ 
elements, where ${\sf C}$ is the 
connectivity matrix, are to binary values $0,1$. The mean is 
over multiple runs:
$$ \rho=\frac{4}{n^2}\sum_{jl}\left({\bar C}_{jl}-1/2\right)^2.$$
Note in the output above that $\rho$ decays from 1 as the number of 
runs increases and then stabilizes. This degree of convergence of 
$\rho$ is a good indication for the adequacy of `nrun`. The cophenetic 
is the correlation between the distance $1-{\sf{\bar C}}$ and the 
height matrix of hierarchical clustering
[@brunet_etal].

To discover clusters of cells, the reduced dimensionality of factorization, 
or the rank $r$, must be estimated. The examples above used a single 
rank value. If the parameter `ranks` is a vector, the set of inferences will 
be repeated for each rank value. 
```{r, cache=T}
sc <- factorize(sc, ranks = seq(3,7), nrun = 5, verbose = 1, progress.bar = FALSE)
```

Note that `nrun` parameter above is set to a small value for illustration. 
In a real application, typical values of `nrun` would be larger. The progress 
bar shown by default under `verbose = 1` for overall `nrun` runs is turned off 
above. It can be set to `TRUE` here (and below) to monitor the progress. 
After factorization, the `measure` slot has been filled:
```{r}
measure(sc)
```

These measures can be plotted (Fig. \@ref(fig:measure)):
```{R measure, fig.large=TRUE, fig.cap='Factorization quality measures as functions of the rank. Dispersion measures the degree of bimodality in consistency matrix. Cophenetic correlation measures the degree of agreement between consistency matrix and hierarchical clustering.'}
plot(sc)
```


## Bayesian NMF
The maximum likelihood-based inference must rely on quality measures to 
choose optimal rank. Bayesian NMF allows for the statistical comparison 
of different models, 
namely those with different ranks. The quantity compared is the log
probability (ML or "evidence") of data conditional to models (defined by rank and hyperparameters).
The main function for Bayesian factorization is `vb_factorize()`:
```{r, cache=T}
sb <- sc_rescue
set.seed(2)
sb <- vb_factorize(sb, ranks =3, verbose = 3, Tol = 2e-4, hyper.update.n0 = 5)
```
The iteration maximizes log ML (per matrix elements)
and terminates when its fractional change becomes smaller than `Tol`. 
The option `criterion = connectivity` can also be used.
By default, hyperparameters of priors are also updated after 
`hyper.update.n0` steps.
As in maximum likelihood, multiple ranks can be specified:
```{r, cache=T}
sb <- vb_factorize(sb, ranks = seq(2,7), nrun = 5, verbose = 1, Tol = 1e-4, progress.bar = FALSE)
```

With `nrun` larger than 1, multiple inferences will be performed for 
each rank with different initial conditions and the solution with the 
highest ML will be chosen. The object after a `vb_factorize` run 
will have its `measure` slot filled:
```{r}
measure(sb)
```

For smaller sample sizes under larger rank values, columns of basis
matrices may turn out to be uniform, which signifies that the 
corresponding cluster is redundant. By default (`unif.stop=TRUE`), 
if such a uniform
column is found in the basis matrix, the rank scan will terminate with
a warning. The last column of `measure` named as `nunif` counts the 
number of such uniform columns found if run under `unif.stop=FALSE`.

Plotting the object displays the log ML 
as a function of rank (Fig. \@ref(fig:lml)):
```{r lml, fig.small=TRUE, fig.cap='Dependence of log ML with rank.'}
plot(sb)
```

The optimal rank is estimated from the rank-evidence profile by:
```{r}
optimal_rank(sb)
```
The heterogeneity class (type I or II) distinguishes cases where
there is a clear and finite optimal rank (type I) from those where
the evidence asymptotically reaches a maximal level (type II) [@woo_etal].
## Visualization
The rank scan above using Bayesian inference correctly identifies 
$r=5$ as the optimal rank. The fit results for each rank--from 
either maximum likelihood or Bayesian inference--are stored 
in `sb@basis` and `sb@coeff`. Both are lists of matrices of length 
equal to the number of rank values scanned. One can access them by, e.g.,
```{r}
ranks(sb)

head(basis(sb)[ranks(sb)==5][[1]]) # basis matrix W for rank 5
```
Heatmaps of $\sf W$ and $\sf H$ matrices are displayed by `feature_map()`
and
`cell_map()`, respectively (Figs. \@ref(fig:sb)-\@ref(fig:sc)):
```{r sb, cache=T, fig.small=TRUE, fig.cap='Heatmap of basis matrix elements. Marker genes selected in rows, other than those provided as input, are based on the degree to which each features strongly in a particular cluster only and not in the rest. Columns represent the clusters.'}
feature_map(sb, markers = markers, rank = 5, max.per.cluster = 4, gene.name = rowData(sb)[,2],
         cexRow = 0.7)
```

In addition to the marker gene list provided as a parameter,
the representative groups of genes for clusters are selected by the 
"max" scheme
[@carmona-saez_etal]: genes are sorted for each cluster with decreasing 
magnitudes of coefficient matrix elements, and among the top members of the 
list, those for which the magnitude is the actual maximum over all clusters 
are chosen. Based on the marker-metagene map in Fig. 6, we rename the 
clusters 1-5 as follows:
```{r}
cell_type <- c('B_cell','CD8+_T','CD4+_T','Monocytes','NK')
colnames(basis(sb)[ranks(sb) == 5][[1]]) <- cell_type
rownames(coeff(sb)[ranks(sb) == 5][[1]]) <- cell_type
```

```{r sc, fig.small=TRUE, fig.cap = 'Heatmap of cluster coefficient matrix elements. Rows indicate clusters and columns the cells.'}
cell_map(sb, rank = 5)
```

In `visualize_clusters()`, each column of $\sf H$ matrix is used to assign 
cells into clusters, and inter/intra-cluster separations are visualized 
using tSNE algorithm [@van_der_maaten_hinton]. It uses the `Rtsne()` 
function of the `Rtsne` package. A barplot of cluster cell counts are 
also displayed (Fig: \@ref(fig:tsne)):
```{r tsne, fig.cap='tSNE-based visualization of clustering. Coefficient matrix elements of cells were used as input with colors indicating predicted cluster assignment. The bar plot shows the cell counts of each cluster.'}
visualize_clusters(sb, rank = 5, cex = 0.7)
```

It is useful to extract hierarchical relationships among the clusters 
identified. This feature requires a series of inference outcomes for an 
uninterrupted range of rank values, e.g., from 2 to 7:
```{r tree, fig.small=TRUE, fig.cap = "Hierarchical tree of clusters derived from varying ranks. The rank increases from 2 to 5 horizontally and nodes are labeled by cluster IDs which bifurcated in each rank."}
tree <- build_tree(sb, rmax = 5)
tree <- rename_tips(tree, rank = 5, tip.labels = cell_type)
plot_tree(tree, cex = 0.8, show.node.label = TRUE)
```

The `build_tree` function returns a list containing the tree. The second 
command above renames the label of terminal nodes by our cell type label. 
In Fig. \@ref(fig:tree), the relative distance between clusters can be seen to be consistent with the tSNE plot in Fig. \@ref(fig:tsne).

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\name{measure<-}
\alias{measure<-}
\title{Generics for factorization measure assignment}
\usage{
measure(object) <- value
}
\arguments{
\item{object}{Object of class \code{scNMFSet}}

\item{value}{Measure to be substituted}
}
\value{
Input object with updated measure
}
\description{
Can be used to access and modify factorization measure
}
\examples{
s <- scNMFSet(count=matrix(rpois(n=12,lambda=3),4,3))
s <- vb_factorize(s, ranks=3)
measure(s)[,-1] <- apply(measure(s)[,-1], c(1,2), round,digits=3)
measure(s)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{write_10x}
\alias{write_10x}
\title{Write 10x data files}
\usage{
write_10x(object, dir, count = "matrix.mtx", genes = "genes.tsv",
  barcodes = "barcodes.tsv", quote = FALSE)
}
\arguments{
\item{object}{Object of class \code{scNMFSet} containing count data}

\item{dir}{Directory where files are to be written.}

\item{count}{File name for count matrix.}

\item{genes}{File name for gene annotation.}

\item{barcodes}{File name for cell annotation.}

\item{quote}{Suppress quotation marks in output files.}
}
\value{
\code{NULL}
}
\description{
Use an object and write count and annotation files in 10x format.
}
\examples{
set.seed(1)
x <- matrix(rpois(n=12,lambda=3),4,3)
rownames(x) <- seq_len(4)
colnames(x) <- seq_len(3)
s <- scNMFSet(count=x,rowData=seq_len(4),colData=seq_len(3))
write_10x(s,dir='.')
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{visualize_clusters}
\alias{visualize_clusters}
\title{Visualize clusters}
\usage{
visualize_clusters(object, rank, verbose = FALSE, cex = 1,
  cex.names = 0.7, ...)
}
\arguments{
\item{object}{\code{scNMF} object.}

\item{rank}{Rank value to extract from \code{object}.}

\item{verbose}{Print tSNE messages.}

\item{cex}{Symbol size in tSNE plot}

\item{cex.names}{Font size of labels in count barplot.}

\item{...}{Other parameters to send to \code{Rtsne}.}
}
\value{
\code{NULL}
}
\description{
Use tSNE to generate two-dimensional map of coefficient matrix.
}
\details{
It retrieves a coefficient matrix \code{H} 
from an object and use its elements
to assign each cell into clusters. 
t-Distributed Stochastic Neighbor Embedding (t-SNE; 
\url{https://lvdmaaten.github.io/tsne/}) is used to visualize the 
clustering
in 2D. Also plotted is the distribution of cell counts for all clusters.
}
\examples{
set.seed(1)
x <- simulate_data(nfeatures=10,nsamples=c(20,20,60,40,30))
rownames(x) <- seq_len(10)
colnames(x) <- seq_len(170)
s <- scNMFSet(count=x,rowData=seq_len(10),colData=seq_len(170))
s <- vb_factorize(s,ranks=seq(2,5))
visualize_clusters(s,rank=5)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{simulate_data}
\alias{simulate_data}
\title{Generate simulated data for factorization}
\usage{
simulate_data(nfeatures, nsamples, generate.factors = FALSE,
  nfactor = 10, alpha0 = 0.5, shuffle = TRUE)
}
\arguments{
\item{nfeatures}{Number of features \code{m} (e.g., genes).}

\item{nsamples}{Vector of sample sizes in each cluster. 
Rank \code{r} is equal to 
    the length of this vector. Sum of elements is the total 
    sample size \code{n}.}

\item{generate.factors}{Generate factor matrices \code{W} and \code{H},
each with dimension \code{n x r} and \code{r x n}. If \code{FALSE},
factor matrices are not used and count data are generated 
directly from
\code{r} multinomials for \code{m} genes.}

\item{nfactor}{Total RNA count of multinomials for each cluster with 
\code{generate.factors = FALSE}. Small \code{nfactor} will 
yield sparse count matrix.}

\item{alpha0}{Variance parameter of Dirichlet distribution from which 
multinomial probabilities are sampled with 
\code{generate.factors = FALSE}.}

\item{shuffle}{Randomly permute rows and columns of count matrix.}
}
\value{
If \code{generate.factors = TRUE}, list of components 
  \code{w} (basis matrix, \code{nfeatures x rank}),
        \code{h} (coefficient matrix, \code{rank x ncells}, where 
        \code{ncells}
        is equal to \code{n}, the sum of \code{nsamples}), and 
        \code{x}, a matrix of Poisson deviates with mean \code{W x H}.
        If \code{generate.factors = FALSE}, only the count matrix 
        \code{x} is in the list.
}
\description{
Use one of two schemes to generate simulated data suitable for 
testing factorization.
}
\details{
In one scheme (\code{generate.factors = TRUE}), simulated factor 
  matrices 
\code{W} and \code{H} are used to build count data \code{X = WH}.
In the second scheme, factor matrices are not used and \code{X} is 
  sampled directly from \code{r} (rank requested) sets of 
  multinomial distributions.
}
\examples{
set.seed(1)
x <- simulate_data(nfeatures=10,nsamples=c(20,20,60,40,30))
s <- scNMFSet(x)
s
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tree.R
\name{newick}
\alias{newick}
\title{Generate Newick format tree string from tree list object}
\usage{
newick(tree, parent = "1.1", string = "")
}
\arguments{
\item{tree}{Tree list object from \code{\link{build_tree}}}

\item{parent}{Parent ID}

\item{string}{Newick string of parent tree}
}
\value{
String of newick tree
}
\description{
Generate Newick format tree string from tree list object
}
\examples{
set.seed(1)
x <- simulate_whx(nrow=50,ncol=100,rank=5)
s <- scNMFSet(x$x)
s <- vb_factorize(s,ranks=seq(2,8),nrun=5)
tree <- build_tree(s,rmax=5)
nw <- newick(tree=tree)
nw
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\docType{methods}
\name{[,scNMFSet,ANY,ANY,ANY-method}
\alias{[,scNMFSet,ANY,ANY,ANY-method}
\alias{[,scNMFSet-method}
\title{Subsetting scNMFSet object}
\usage{
\S4method{[}{scNMFSet,ANY,ANY,ANY}(x, i, j)
}
\arguments{
\item{x}{Object to be subsetted}

\item{i}{row index}

\item{j}{column index}
}
\value{
Subsetted object
}
\description{
Subsetting scNMFSet object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\docType{methods}
\name{measure,scNMFSet-method}
\alias{measure,scNMFSet-method}
\title{Rank measure accessor}
\usage{
\S4method{measure}{scNMFSet}(object)
}
\arguments{
\item{object}{Object containing measure}
}
\value{
Data frame of measure
}
\description{
Rank measure accessor
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\name{dbasis}
\alias{dbasis}
\title{Basis SD matrix accessor}
\usage{
dbasis(object)
}
\arguments{
\item{object}{Object containing dbasis matrix}
}
\value{
List of dbasis matrices
}
\description{
Basis SD matrix accessor
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tree.R
\name{plot_tree}
\alias{plot_tree}
\title{Plot cluster tree}
\usage{
plot_tree(tree, direction = "rightwards", cex = 0.7, ...)
}
\arguments{
\item{tree}{List containing tree structure. Output from 
\code{\link{build_tree}}}

\item{direction}{\code{c('rightwards','downwards')}; 
the direction of dendrogram}

\item{cex}{Font size of edge/tip labels}

\item{...}{Other parameters to \code{\link{plot.phylo}}}
}
\value{
\code{NULL}
}
\description{
Visualize the output of \code{\link{build_tree}} as a dendrogram.
}
\details{
Uses \code{\link[ape]{plot.phylo}} to visualize cluster tree.
}
\examples{
set.seed(1)
x <- simulate_whx(nrow=50,ncol=100,rank=5)
s <- scNMFSet(x$x)
s <- vb_factorize(s,ranks=seq(2,8),nrun=5)
tree <- build_tree(s,rmax=5)
plot_tree(tree)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\docType{methods}
\name{counts<-,scNMFSet-method}
\alias{counts<-,scNMFSet-method}
\title{Assignment of count matrix}
\usage{
\S4method{counts}{scNMFSet}(object) <- value
}
\arguments{
\item{object}{Object containing count}

\item{value}{Matrix-like object for replacement}
}
\value{
Object with updated count
}
\description{
Count matrix can be modified
}
\examples{
mat <- matrix(rpois(n=12,lambda=3),3,4)
s <- scNMFSet(count = mat)
counts(s) <- mat^2
counts(s)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\docType{methods}
\name{dcoeff<-,scNMFSet-method}
\alias{dcoeff<-,scNMFSet-method}
\title{Modify dcoeff matrices}
\usage{
\S4method{dcoeff}{scNMFSet}(object) <- value
}
\arguments{
\item{object}{Object of class \code{scNMFSet}}

\item{value}{Coeff SD matrix to be substituted}
}
\value{
Updated object
}
\description{
Access and modify dcoeff matrices
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\docType{methods}
\name{basis<-,scNMFSet-method}
\alias{basis<-,scNMFSet-method}
\title{Modify basis matrices}
\usage{
\S4method{basis}{scNMFSet}(object) <- value
}
\arguments{
\item{object}{Object of class \code{scNMFSet}}

\item{value}{Basis matrix to be substituted}
}
\value{
Input object with updated basis matrices
}
\description{
Access and modify basis matrices
}
\examples{
set.seed(1)
s <- scNMFSet(count=matrix(rpois(n=12,lambda=3),4,3))
s <- vb_factorize(s, ranks=3)
basis(s)[[1]] <- apply(basis(s)[[1]],c(1,2),round,digits=3)
basis(s)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\name{dbasis<-}
\alias{dbasis<-}
\title{Basis SD matrix assignment}
\usage{
dbasis(object) <- value
}
\arguments{
\item{object}{Object containing dbasis matrix}

\item{value}{List for assignment}
}
\value{
Updated object
}
\description{
Basis SD matrix assignment
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\docType{methods}
\name{colData<-,scNMFSet,ANY-method}
\alias{colData<-,scNMFSet,ANY-method}
\title{Cell annotation assignment}
\usage{
\S4method{colData}{scNMFSet,ANY}(x) <- value
}
\arguments{
\item{x}{Object containing cell annotation}

\item{value}{DataFrame to be substituted}
}
\value{
Updated column annotation
}
\description{
Cell annotation assignment
}
\examples{
library(S4Vectors)
x <- matrix(rpois(n=12,lambda=3),4,3)
rownames(x) <- seq_len(4)
colnames(x) <- c('a','b','c')
s <- scNMFSet(count=x,rowData=seq_len(4),colData=c('a','b','c'))
cols <- DataFrame(tissue=c('tissue1','tissue1','tissue2'))
rownames(cols) <- c('a','b','c')
colData(s) <- cols
s
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{feature_map}
\alias{feature_map}
\title{Plot heatmap of basis matrix}
\usage{
feature_map(object, basis.matrix = NULL, rank, markers = NULL,
  subtract.mean = TRUE, log = TRUE, max.per.cluster = 10,
  feature.names = NULL, perm = NULL, main = "Feature map",
  cscale = NULL, cex.cluster = 1, cex.feature = 0.5, mar = NULL,
  ...)
}
\arguments{
\item{object}{Object of class \code{scNMFSet}.}

\item{basis.matrix}{Basis matrix can be supplied instead of \code{object}.}

\item{rank}{Rank value for which the gene map is to be displayed. 
The object must contain the corresponding slot (one element of 
     \code{basis(object)[[k]]} for which \code{ranks(object)[[k]]==rank}.}

\item{markers}{Vector of gene names containing markers to be included 
in addition to the metagenes. All entries of \code{rowData(object)}
matching them will be added to the metagene list.}

\item{subtract.mean}{Process each rows of basis matrix \code{W} by 
standardization using the mean of elements within the row.}

\item{log}{If \code{TRUE}, \code{subtract.mean} uses geometric mean
and division. Otherwise, use arithmetic mean and subtraction.}

\item{max.per.cluster}{Maximum number of metagenes per cluster.}

\item{feature.names}{Names to be used in the plot for features.}

\item{perm}{Permutation of cluster IDs.}

\item{main}{Main title.}

\item{cscale}{Colors for heatmap.}

\item{cex.cluster}{Cluster ID label size.}

\item{cex.feature}{Feature ID label size.}

\item{mar}{Margins for \code{graphics::par}.}

\item{...}{Other arguments to be passed to \code{\link{image}}, and 
\code{\link{plot}}.}
}
\value{
\code{NULL}
}
\description{
Generate heatmap of features derived from factorization of count data.
}
\details{
This function uses \code{image()} and is more flexible than 
\code{gene_map}.

If \code{object} contains multiple ranks, only the requested 
  rank's basis matrix W will be displayed. As in \code{gene_map}, the features
  displayed in rows are selected by "max" scheme
}
\examples{
 
set.seed(1)
x <- simulate_data(nfeatures=10,nsamples=c(20,20,60))
rownames(x) <- seq_len(10)
 
set.seed(1)
x <- simulate_data(nfeatures=10,nsamples=c(20,20,60))
rownames(x) <- seq_len(10)
colnames(x) <- seq_len(100)
s <- scNMFSet(count=x,rowData=seq_len(10), colData=seq_len(100))
s <- vb_factorize(s,ranks=seq(2,5))
plot(s)
feature_map(s, rank=3)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ccfindR.R
\docType{package}
\name{ccfindR}
\alias{ccfindR}
\alias{ccfindR-package}
\title{ccfindR: Cancer Clone FindeR}
\description{
This package contains tools and utilities for cell-type discovery
using single-cell transcriptomic data while evaluating significance
of the depth of clustering \insertCite{woo_etal}{ccfindR}.
}
\references{
\insertRef{woo_etal}{ccfindR}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\docType{methods}
\name{rowData,scNMFSet-method}
\alias{rowData,scNMFSet-method}
\title{Feature annotation accessor}
\usage{
\S4method{rowData}{scNMFSet}(x)
}
\arguments{
\item{x}{Object containing data}
}
\value{
DataFrame of feature annotation
}
\description{
Feature annotation accessor
}
\examples{
x <- matrix(rpois(n=12,lambda=3),4,3)
rownames(x) <- seq_len(4)
colnames(x) <- seq_len(3)
s <- scNMFSet(count=x,rowData=seq_len(4),colData=seq_len(3))
rowData(s) 
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{cell_map}
\alias{cell_map}
\title{Plot heatmap of clustering coefficient matrix}
\usage{
cell_map(object, rank, main = "Cells", ...)
}
\arguments{
\item{object}{Object of class \code{scNMFSet}.}

\item{rank}{Rank value for which the cell map is to be displayed. 
The object must contain the corresponding slot: one element of 
          \code{coeff(object)[[k]]} for which 
          \code{ranks(object)[[k]]==rank}.}

\item{main}{Title of plot.}

\item{...}{Other arguments to be passed to \code{\link{heatmap}}, 
\code{\link{image}},
           and \code{\link{plot}}.}
}
\value{
\code{NULL}
}
\description{
Retrieve a coefficient matrix \code{H}
derived from factorization by rank value
and generate heatmap of its elements.
}
\examples{
set.seed(1)
x <- simulate_data(nfeatures=10,nsamples=c(20,20,60))
rownames(x) <- seq_len(10)
colnames(x) <- seq_len(100)
s <- scNMFSet(count=x,rowData=seq_len(10),colData=seq_len(100))
s <- vb_factorize(s,ranks=seq(2,5))
plot(s)
cell_map(s, rank=3)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{read_10x}
\alias{read_10x}
\title{Read 10x data and generate scNMF object}
\usage{
read_10x(dir, count = "matrix.mtx", genes = "genes.tsv",
  barcodes = "barcodes.tsv", remove.zeros = TRUE)
}
\arguments{
\item{dir}{Name of directory containing data files.}

\item{count}{Name of count matrix file.}

\item{genes}{Name of gene annotation file.}

\item{barcodes}{Name of cell annotation file.}

\item{remove.zeros}{If \code{TRUE}, empty rows/columns are 
removed.}
}
\value{
Object of class \code{scNMFSet}
}
\description{
Read count, gene, and barcode annotation data in 10x format 
and create an object of class \code{scNMFSet}.
}
\details{
Files for \code{count}, \code{genes}, and \code{barcodes} are
assumed to be present in \code{dir}. 
Count data are in sparse "Matrix Market" format 
(\url{https://math.nist.gov/MatrixMarket/formats.html}).
}
\examples{
library(S4Vectors)
s <- scNMFSet(count=matrix(rpois(n=12,lambda=3),4,3))
rowData(s) <- DataFrame(seq_len(4))
colData(s) <- DataFrame(seq_len(3))
write_10x(s,dir='.')
s <- read_10x(dir='.')
s
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils2.R
\name{meta_gene.cv}
\alias{meta_gene.cv}
\title{Meta gene table with CV}
\usage{
meta_gene.cv(object = NULL, rank, basis.matrix = NULL, dbasis = NULL,
  max.per.cluster = 100, gene_names = NULL, subtract.mean = TRUE,
  log = TRUE, cv.max = Inf)
}
\arguments{
\item{object}{Main object containing factorization outcome}

\item{rank}{Rank for which meta gene is to be found}

\item{basis.matrix}{Basis matrix to work with. Only necessary when 
\code{object} is \code{NULL}.}

\item{dbasis}{Variance of basis matrix. Only necessary when 
\code{object} is \code{NULL}.}

\item{max.per.cluster}{Maximum meta genes per cluster.}

\item{gene_names}{Name of genes. If \code{NULL}, will be taken from row names.}

\item{subtract.mean}{Standardize magnitudes of basis elements by subtracting mean}

\item{log}{Use geometric mean.}

\item{cv.max}{Upper bound for CV in selecting meta genes.}
}
\value{
Data frame with meta genes and their CV in each column.
}
\description{
Generates meta gene table with coefficient of variation
}
\examples{
set.seed(1)
x <- simulate_whx(nrow=50, ncol=100, rank=5)
s <- scNMFSet(x$x)
s <- vb_factorize(s, ranks=seq(2,8), nrun=5)
plot(s)
meta_gene.cv(s, rank=5)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{cluster_id}
\alias{cluster_id}
\title{Assign cells into clusters}
\usage{
cluster_id(object, rank = 2)
}
\arguments{
\item{object}{Object of class \code{scNMFSet}}

\item{rank}{Rank value whose factor matrices are to be used for 
assignment.}
}
\value{
Vector of length equal to the number of cells containing 
     cluster ID numbers of each cell.
}
\description{
Use factorization results in an object to assign cells into clusters.
}
\examples{
set.seed(1)
x <- simulate_whx(nrow=50,ncol=100,rank=5)
s <- scNMFSet(count=x$x)
s <- vb_factorize(s,ranks=seq(2,8),nrun=5)
cid <- cluster_id(s, rank=5)
table(cid)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{simulate_whx}
\alias{simulate_whx}
\title{Simulate factor matrices and data using priors}
\usage{
simulate_whx(nrow, ncol, rank, aw = 0.1, bw = 1, ah = 0.1, bh = 1)
}
\arguments{
\item{nrow}{Number of features (genes).}

\item{ncol}{Number of cells (samples).}

\item{rank}{Rank (ncol of W, nrow of H).}

\item{aw}{Shape parameter of basis prior.}

\item{bw}{Mean of basis prior. Scale parameter is equal to \code{aw/bw}.}

\item{ah}{Shape parameter of coefficient prior.}

\item{bh}{Mean of coefficient prior. Scale parameter is equal to 
\code{ah/bh}.}
}
\value{
List with elements \code{w}, \code{h}, and \code{x}, each 
   containing basis, coefficient, and count matrices.
}
\description{
Under Bayesian formulation, use prior distributions of factor matrices
and generate simulated data
}
\details{
Basis \code{W} and coefficient matrices \code{H} are sampled from 
gamma distributions (priors) with shape (\code{aw,ah}) and mean
(\code{bw,bh}) parameters. Count data \code{X} are sampled from Poisson
distribution with mean values given by \code{WH}.
}
\examples{
set.seed(1)
x <- simulate_whx(nrow=50,ncol=100,rank=5)
s <- scNMFSet(count=x$x)
s <- vb_factorize(s,ranks=seq(2,8),nrun=5)
plot(s)  
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\name{dcoeff}
\alias{dcoeff}
\title{Coeff SD matrix accessor}
\usage{
dcoeff(object)
}
\arguments{
\item{object}{Object containing dcoeff matrix}
}
\value{
List of dcoeff matrices
}
\description{
Coeff SD matrix accessor
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils2.R
\name{optimal_rank}
\alias{optimal_rank}
\title{Determine optimal rank}
\usage{
optimal_rank(object, df = 10, BF.threshold = 3, type = NULL,
  m = NULL)
}
\arguments{
\item{object}{\code{scNMFSet} object containing factorization output, or 
data frame containing the rank-evidence profile.}

\item{df}{Degrees of freedom for split fit. Upper bound is the total number of
data points (number of rank values scanned).}

\item{BF.threshold}{Bayes factor threshold for statistical threshold.}

\item{type}{\code{c(1,2)}. Type 1 is where there is a clear maximum. Type 2 
is where marginal likelihood reaches a maximal level and stays constant.
If omitted, the type will be inferred from data.}

\item{m}{Number of features (e.g., genes) in the count matrix. Only necessary when
\code{object} is of type \code{data.frame}.}
}
\value{
List containing \code{type} and \code{ropt} (optimal rank).
}
\description{
Takes as main argument \code{scNMFSet} object containing factorized output
and estimate the optimal rank.
}
\details{
The input object is used along with Bayes factor threshold to determine the
         heterogeneity type (1 or 2) and the optimal rank. 
         If evidence(rank 1)/evidence(rank2) > \code{BF.treshold}, rank 1 is favorable than rank 2.
}
\examples{
set.seed(1)
x <- simulate_whx(nrow=50, ncol=100, rank=5)
s <- scNMFSet(x$x)
s <- vb_factorize(s, ranks=seq(2,8), nrun=5)
plot(s)
optimal_rank(s)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{normalize_count}
\alias{normalize_count}
\title{Normalize count data}
\usage{
normalize_count(object)
}
\arguments{
\item{object}{\code{scNMFSet} object.}
}
\value{
\code{scNMFSet} object with normalized count data.
}
\description{
Rescale count matrix entries such that all cells have the same library size.
}
\details{
For analysis purposes, it is sometimes useful to rescale integer count
data into floats such that all cells have the same median counts. 
This function will calculate the median of all UMI counts of cells (total
number of RNAs derived from each cell). All count data are then rescaled
such that cells have uniform UMI count equal to the median.
}
\examples{
library(Matrix)
set.seed(1)
s <- scNMFSet(count=matrix(rpois(n=1200,lambda=3),40,30))
colMeans(counts(s))
s <- normalize_count(s)
colMeans(counts(s))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\name{remove_zeros}
\alias{remove_zeros}
\title{Remove rows or columns that are empty from an object}
\usage{
remove_zeros(object)
}
\arguments{
\item{object}{Object containing data}
}
\value{
Object with empty rows/columns removed
}
\description{
Remove rows or columns that are empty from an object
}
\examples{
set.seed(1)
x <- matrix(rpois(n=100,lambda=0.1),10,10)
s <- scNMFSet(count=x,remove.zeros=FALSE)
s2 <- remove_zeros(s)
s2
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{plot_genes}
\alias{plot_genes}
\title{Plot gene variance distributions}
\usage{
plot_genes(object, vmr = NULL, ncexpr = NULL, selected_genes = NULL,
  variable_genes = NULL, mode_genes = NULL, marker_genes = NULL,
  save.memory = FALSE, progress.bar = TRUE, log = "xy", cex = 0.5)
}
\arguments{
\item{object}{Object containing count data}

\item{vmr}{Variance to mean ratio (VMR)}

\item{ncexpr}{Number of cells expressing each gene}

\item{selected_genes}{Logical vector specifing genes selected}

\item{variable_genes}{Logical vector specifing genes with high VMR}

\item{mode_genes}{Logical vector specifying genes with nonzero modes}

\item{marker_genes}{Logical vector specifying marker genes}

\item{save.memory}{If \code{TRUE}, calculate VMR using slower
method to save memory. Not used when gene lists are supplied.}

\item{progress.bar}{Display progress bar for VMR calculation.
Not used when gene lists are supplied.}

\item{log}{Axis in log-scale, \code{c('x','y','xy')}.}

\item{cex}{Symbol size for genes (supplied to \code{plot()}).}
}
\value{
\code{NULL}
}
\description{
Gene variance to mean ratio and the number of expressing cells are
plotted.
}
\details{
This function can be called separately or is also called within
\code{\link{filter_genes}} by default. 
In the latter case, parameters other
than \code{object} will have been already filled. If called separately
with \code{NULL} gene lists, VMR is recalculated but gene selection
is not done.
}
\examples{
set.seed(1)
s <- scNMFSet(matrix(stats::rpois(n=1200,lambda=3),40,30))
plot_genes(s)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\docType{methods}
\name{dcoeff,scNMFSet-method}
\alias{dcoeff,scNMFSet-method}
\title{Coeffcient SD matrix accessor}
\usage{
\S4method{dcoeff}{scNMFSet}(object)
}
\arguments{
\item{object}{Object containing coeffient standard deviation (SD) matrix}
}
\value{
List of dcoeff matrices
}
\description{
Coeffcient SD matrix accessor
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\name{coeff<-}
\alias{coeff<-}
\title{Generics for coefficient matrix assignment}
\usage{
coeff(object) <- value
}
\arguments{
\item{object}{Object of class \code{scNMFSet}}

\item{value}{Coefficient matrix to be substituted}
}
\value{
Input object with updated coefficient matrices
}
\description{
Access and modify coefficient matrices
}
\examples{
s <- scNMFSet(count=matrix(rpois(n=12,lambda=3),4,3))
s <- vb_factorize(s, ranks=3)
coeff(s)[[1]] <- apply(coeff(s)[[1]],c(1,2),round,digits=2)
coeff(s)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{filter_genes}
\alias{filter_genes}
\title{Filter genes with quality control criteria}
\usage{
filter_genes(object, markers = NULL, vmr.min = 0,
  min.cells.expressed = 0, max.cells.expressed = Inf,
  rescue.genes = FALSE, progress.bar = TRUE, save.memory = FALSE,
  plot = TRUE, log = "xy", cex = 0.5)
}
\arguments{
\item{object}{\code{scNMFSet} object.}

\item{markers}{A vector containing marker genes to be selected. 
   All rows in 
\code{rowData} that contain columns matching this set will 
   be selected.}

\item{vmr.min}{Minimum variance-to-mean ratio for gene filtering.}

\item{min.cells.expressed}{Minimum no. of cells expressed for gene 
filtering.}

\item{max.cells.expressed}{Maximum no. of cells expressed for gene 
filtering.}

\item{rescue.genes}{Selected additional genes whose (non-zero)
count distributions have at least one mode.}

\item{progress.bar}{Display progress of mode-gene scan or VMR
calculation with \code{save.memory = TRUE}.}

\item{save.memory}{For a very large number of cells, calculate VMR 
row by row while avoiding calls to \code{as.matrix()}.
Progress bar will be displayed unless \code{progress.bar=FALSE}.}

\item{plot}{Plot the distribution of no. of cells expressed vs. VMR.}

\item{log}{Axis in log-scale, \code{c('x','y','xy')}.}

\item{cex}{Symbol size for each gene in the plot.}
}
\value{
Object of class \code{scNMFSet}.
}
\description{
Select genes with high relative variance in count data for 
further analysis
}
\details{
Takes as input \code{scNMFSet} object and scatterplot no. of cells 
expressed versus VMR (variance-to-mean ratio)
for each gene. Optionally, genes are filtered using minimum VMR 
together with a range of no. of cells expressed.
}
\examples{
set.seed(1)
s <- scNMFSet(matrix(stats::rpois(n=1200,lambda=3),40,30))
s <- filter_genes(s,vmr.min=1.0,min.cells.expressed=28,
        rescue.genes=FALSE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\docType{methods}
\name{ranks<-,scNMFSet-method}
\alias{ranks<-,scNMFSet-method}
\title{Modify ranks}
\usage{
\S4method{ranks}{scNMFSet}(object) <- value
}
\arguments{
\item{object}{Object of class \code{scNMFSet}}

\item{value}{Rank values (vector) to be substituted}
}
\value{
Input object with updated ranks
}
\description{
Replace \code{ranks} slot of \code{scNMFSet} object
}
\examples{
s <- scNMFSet(count=matrix(rpois(n=12,lambda=3),4,3))
s <- vb_factorize(s, ranks=seq(2,3))
ranks(s) <- c('two','three')
ranks(s)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gsea.R
\name{assignCelltype}
\alias{assignCelltype}
\title{Cell type assignment via GSEA}
\usage{
assignCelltype(obj, rank, gset, gene_names = NULL, p = 0,
  remove.na = FALSE, p.value = FALSE, nperm = 1000,
  progress.bar = TRUE, grp.prefix = c("IG"))
}
\arguments{
\item{obj}{Object of class \code{scNMFSet}.}

\item{rank}{Rank to examine}

\item{gset}{List of gene sets to be used as markers}

\item{gene_names}{Names of genes to be used for meta-gene identification}

\item{p}{Enrichment score exponent.}

\item{remove.na}{Remove gene sets with no overlap}

\item{p.value}{Estimatte p values using permutation}

\item{nperm}{No. of permutation replicates}

\item{progress.bar}{Display progress bar for p value computation}

\item{grp.prefix}{Gene name prefix to search for with wildcard matches in query}
}
\value{
Matrix of enrichment score statistics with cell types in rows and
        clusters in columns
}
\description{
Computes GSEA enrichment score of marker sets in meta gene list
}
\details{
If \code{obj} is of clas \code{scNMFSet}, it computes meta gene list using
\code{\link{meta_gene.cv}}. Otherwise, \code{obj} is expected to be 
a data frame of the same structure as the output of \code{meta_gene.cv};
the number of rows same as the total number of metagenes per cluster, 
three columns per each cluster (gene name, meta-gene score, and coefficient of variation).
The argument \code{gset} is a list of gene sets to be checked for enrichment in 
each cluster meta gene list. The enrichment score is computed using 
the GSEA algorithm \insertCite{subramanian_etal}{ccfindR}.
}
\examples{
dir <- system.file('extdata',package='ccfindR')
pbmc <- read_10x(dir)
pbmc <- vb_factorize(pbmc, ranks=5)
meta <- meta_gene.cv(pbmc,rank=5, gene_names=rowData(pbmc)[,2])
markers <- list('B cell'=c('CD74','IG','HLA'),
                'CD8+ T'=c('CD8A','CD8B','GZMK','CCR7','LTB'),
                'CD4+ T'=c('CD3D','CD3E','IL7R','LEF1'),
                'NK'=c('GNLY','NKG7','GZMA','GZMH'),
                'Macrophage'=c('S100A8','S100A9','CD14','LYZ','CFD'))
gsea <- assignCelltype(meta, rank=5, gset=markers, grp.prefix=c('IG','HLA'))
gsea
}
\references{
\insertRef{subramanian_etal}{ccfindR}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\docType{methods}
\name{ranks,scNMFSet-method}
\alias{ranks,scNMFSet-method}
\title{Rank accessor}
\usage{
\S4method{ranks}{scNMFSet}(object)
}
\arguments{
\item{object}{Object containing rank values}
}
\value{
Vector of rank values
}
\description{
Rank accessor
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\docType{methods}
\name{rowData<-,scNMFSet-method}
\alias{rowData<-,scNMFSet-method}
\title{Gene annotation assignment}
\usage{
\S4method{rowData}{scNMFSet}(x) <- value
}
\arguments{
\item{x}{Object containing data}

\item{value}{DataFrame of row annotation to be substituted}
}
\value{
Row annotation DataFrame
}
\description{
Gene annotation assignment
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\docType{methods}
\name{coeff,scNMFSet-method}
\alias{coeff,scNMFSet-method}
\title{Coefficient matrix accessor}
\usage{
\S4method{coeff}{scNMFSet}(object)
}
\arguments{
\item{object}{Object containing coefficient matrix}
}
\value{
List of coefficient matrices
}
\description{
Coefficient matrix accessor
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bayesian.R
\name{vb_factorize}
\alias{vb_factorize}
\title{Bayesian NMF inference of count matrix}
\usage{
vb_factorize(object, ranks = 2, nrun = 1, verbose = 2,
  progress.bar = TRUE, initializer = "random", Itmax = 10000,
  hyper.update = rep(TRUE, 4), gamma.a = 1, gamma.b = 1,
  Tol = 1e-05, hyper.update.n0 = 10, hyper.update.dn = 1,
  connectivity = TRUE, fudge = NULL, ncores = 1, useC = TRUE,
  unif.stop = TRUE)
}
\arguments{
\item{object}{\code{scNMFSet} object containing count matrix.}

\item{ranks}{Rank for factorization; can be a vector of multiple values.}

\item{nrun}{No. of runs with different initial guesses.}

\item{verbose}{The verbosity level: 
3, each iteration output printed;
2, each run output printed; 
1, each randomized sample output printed;
0, silent.}

\item{progress.bar}{Display progress bar with \code{verbose = 1} for 
multiple runs.}

\item{initializer}{If \code{'random'}, randomized initial conditions; 
\code{'svd2'} for singular value decomposed initial condition.}

\item{Itmax}{Maximum no. of iteration.}

\item{hyper.update}{Vector of four logicals, each indcating whether
hyperparameters \code{c(aw, bw, ah, bh)} should be optimized.}

\item{gamma.a}{Gamma distribution shape parameter.}

\item{gamma.b}{Gamma distribution mean. These two parameters are used for 
fixed hyperparameters with \code{hyper.update} elements \code{FALSE}.}

\item{Tol}{Tolerance for terminating iteration.}

\item{hyper.update.n0}{Initial number of steps in which hyperparameters 
are fixed.}

\item{hyper.update.dn}{Step intervals for hyperparameter updates.}

\item{connectivity}{If \code{TRUE}, connectivity and dispersion will
be calculated after each run. Can be turned off to save memory.}

\item{fudge}{Small positive number used as lower bound for factor matrix 
elements to avoid singularity. If \code{fudge = NULL} (default), 
it will be replaced by \code{.Machine$double.eps}. 
Can be set to 0 to skip 
regularization.}

\item{ncores}{Number of processors (cores) to run. If \code{ncores > 1},
parallelization is attempted.}

\item{useC}{Use C++ version of updates for speed.}

\item{unif.stop}{Terminate if any of columns in basis matrix is uniform.}
}
\value{
Object of class \code{scNMFSet} with factorization slots filled.
}
\description{
Perform variational Bayes NMF and store factor matrices in object
}
\details{
The main input is the \code{scNMFSet} object with count matrix.
This function performs non-negative factorization using Bayesian algorithm
and gamma priors. Slots \code{basis}, \code{coeff}, and \code{ranks} 
are filled.

When run with multiple values of \code{ranks}, factorization is 
       repeated for each rank and the slot \code{measure} contains 
       log evidence and optimal hyperparameters for each rank. 
       With \code{nrun > 1}, the solution
       with the maximum log evidence is stored for a given rank.
}
\examples{
set.seed(1)
x <- simulate_whx(nrow=50,ncol=100,rank=5)
s <- scNMFSet(x$x)
s <- vb_factorize(s,ranks=seq(2,8),nrun=5)
plot(s)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\name{measure}
\alias{measure}
\title{Factorization measures in an Object}
\usage{
measure(object)
}
\arguments{
\item{object}{Object of class \code{scNMFSet}.}
}
\value{
Either \code{NULL} or a data frame containing measures.
}
\description{
Retrieve or set factorization measures in an object
}
\details{
Factorization under multiple rank values lead to measures stored in
a data frame inside a slot \code{measure}. In maximum likelihood using
\code{\link{factorize}}, this set of quality measures include 
dispersion and cophenetic
coeeficients for each rank. In Bayesian factorization using 
\code{\link{vb_factorize}},
log evidence for each rank is stored. \code{measure(object)} 
will return the data
frame. \code{measure(object) <- value}
can be used to modify it.
}
\examples{
s <- scNMFSet(count=matrix(rpois(n=12,lambda=3),4,3))
s <- vb_factorize(s,ranks=seq(2,4))
measure(s)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{gene_map}
\alias{gene_map}
\title{Plot heatmap of metagene matrix}
\usage{
gene_map(object, rank, markers = NULL, subtract.mean = TRUE,
  log = TRUE, max.per.cluster = 10, Colv = NA, gene.names = NULL,
  main = "Genes", col = NULL, ...)
}
\arguments{
\item{object}{Object of class \code{scNMFSet}.}

\item{rank}{Rank value for which the gene map is to be displayed. 
The object must contain the corresponding slot (one element of 
     \code{basis(object)[[k]]} for which \code{ranks(object)[[k]]==rank}.}

\item{markers}{Vector of gene names containing markers to be included 
in addition to the metagenes. All entries of \code{rowData(object)}
matching them will be added to the metagene list.}

\item{subtract.mean}{Process each rows of basis matrix \code{W} by 
standardization using the mean of elements within the row.}

\item{log}{If \code{TRUE}, \code{subtract.mean} uses geometric mean
and division. Otherwise, use arithmetic mean and subtraction.}

\item{max.per.cluster}{Maximum number of metagenes per cluster.}

\item{Colv}{\code{NA} suppresses reordering and dendrogram of clusters
along the column. See \code{\link[stats]{heatmap}}.}

\item{gene.names}{Names to be used in the plot for genes.}

\item{main}{Title of plot.}

\item{col}{Colors for the cluster panels on the left and top.}

\item{...}{Other arguments to be passed to \code{\link{heatmap}}, 
\code{\link{image}}, and \code{\link{plot}}.}
}
\value{
\code{NULL}
}
\description{
Generate heatmap of metagenes derived from factorization of count data.
}
\details{
Wrapper for \code{\link[stats]{heatmap}} to display metagenes and
associated basis matrix element magnitudes. Factorization results inside
an object specified by its rank value will be retrieved, and metagene
sets identified from clusters.

If \code{object} contains multiple ranks, only the requested 
  rank's basis matrix W will be displayed. The genes displayed in rows
     are selected by "max" scheme
    [Carmona-Saez, BMC Bioinformatics (2006), 
   \url{https://doi.org/10.1186/1471-2105-7-54}]:
     for each cluster (\code{k in 1:ncol}), 
     rows of W are sorted by decreasing order
     of \code{W[,k]}. Marker genes for \code{k} are those among the top
     \code{nmarker} for which \code{W[,k]} is maximum within each row.
}
\examples{
 
set.seed(1)
x <- simulate_data(nfeatures=10,nsamples=c(20,20,60))
rownames(x) <- seq_len(10)
colnames(x) <- seq_len(100)
s <- scNMFSet(count=x,rowData=seq_len(10), colData=seq_len(100))
s <- vb_factorize(s,ranks=seq(2,5))
plot(s)
gene_map(s, rank=3)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tree.R
\name{build_tree}
\alias{build_tree}
\title{Build tree connecting clusters at different ranks}
\usage{
build_tree(object, rmax)
}
\arguments{
\item{object}{Object of class \code{scNMFSet}}

\item{rmax}{Maximum rank at which tree branching stops}
}
\value{
List containing the tree structure
}
\description{
Build tree connecting clusters at different ranks
}
\examples{
set.seed(1)
x <- simulate_whx(nrow=50,ncol=100,rank=5)
s <- scNMFSet(x$x)
s <- vb_factorize(s,ranks=seq(2,8),nrun=5)
tree <- build_tree(s,rmax=5)
tree
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\name{ranks}
\alias{ranks}
\title{Rank values in an Object}
\usage{
ranks(object)
}
\arguments{
\item{object}{Object of class \code{scNMFSet}.}
}
\value{
Either \code{NULL} or vector.
}
\description{
Retrieve or set the rank values in an object
}
\details{
Ranks for which factorization has been performed are stored 
in slot \code{ranks} of \code{scNMFSet} object.
\code{ranks(object)} will return the rank vector. 
\code{ranks(object) <- value}
can be used to modify it.
}
\examples{
s <- scNMFSet(matrix(rpois(n=12,lambda=3),4,3))
s <- vb_factorize(s,ranks=seq(2,4))
ranks(s)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{meta_genes}
\alias{meta_genes}
\title{Find metagenes from basis matrix}
\usage{
meta_genes(object, rank, basis.matrix = NULL, max.per.cluster = 10,
  gene_names = NULL, subtract.mean = TRUE, log = TRUE)
}
\arguments{
\item{object}{Object of class \code{scNMFSet}.}

\item{rank}{Rank value for which metagenes are to be found.}

\item{basis.matrix}{Instead of an object containing basis 
matrices, the matrix itself can be provided.}

\item{max.per.cluster}{Maximum number of metagenes per cluster.}

\item{gene_names}{Names of genes to replace row names of basis matrix.}

\item{subtract.mean}{Standardize the matrix elements with means 
within each row.}

\item{log}{Use geometric mean and division instead of arithmetic 
mean and subtraction with \code{subtract.mean}.}
}
\value{
List of vectors each containing metagene names of clusters.
}
\description{
Retrieve a basis matrix from an object and find metagenes.
}
\examples{
set.seed(1)
x <- simulate_data(nfeatures=10,nsamples=c(20,20,60))
rownames(x) <- seq_len(10)
colnames(x) <- seq_len(100)
s <- scNMFSet(count=x,rowData=seq_len(10),colData=seq_len(100))
s <- vb_factorize(s,ranks=seq(2,5))
meta_genes(s, rank=4)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{filter_cells}
\alias{filter_cells}
\title{Filter cells with quality control criteria}
\usage{
filter_cells(object, umi.min = 0, umi.max = Inf, plot = TRUE,
  remove.zeros = TRUE)
}
\arguments{
\item{object}{\code{scNMFSet} object}

\item{umi.min}{Minimum UMI count for cell filtering}

\item{umi.max}{Maximum UMI count for cell filtering}

\item{plot}{If \code{TRUE}, the UMI count distribution of all cells 
will be displayed. Cells selected are colored red.}

\item{remove.zeros}{Remove rows/columns containing zeros only}
}
\value{
\code{scNMFSet} object with cells filtered.
}
\description{
Remove low quality cell entries from object
}
\details{
Takes as input \code{scNMFSet} object and plots histogram of UMI 
counts for each 
cell. Optionally, cells are filtered using minimum and maximum UMI counts. 
The resulting object is returned after removing empty rows and columns, 
if any.
}
\examples{
set.seed(1)
s <- scNMFSet(matrix(stats::rpois(n=1200,lambda=3),40,30))
s <- filter_cells(s,umi.min=10^2.0,umi.max=10^2.1)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\name{scNMFSet}
\alias{scNMFSet}
\title{Create \code{scNMFSet} object}
\usage{
scNMFSet(count = NULL, ..., remove.zeros = TRUE)
}
\arguments{
\item{count}{Count matrix}

\item{...}{Other parameters of \code{\link{SingleCellExperiment}}}

\item{remove.zeros}{Remove empty rows and columns}
}
\value{
Object of class \code{scNMFSet}.
}
\description{
Object derived from \code{\link{SingleCellExperiment}}
}
\examples{
count <- matrix(rpois(n=12,lambda=2),4,3)
s <- scNMFSet(count=count)
s
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\docType{methods}
\name{show,scNMFSet-method}
\alias{show,scNMFSet-method}
\title{Display object}
\usage{
\S4method{show}{scNMFSet}(object)
}
\arguments{
\item{object}{Object of class \code{scNMFSet}}
}
\value{
\code{NULL}
}
\description{
Display the class and dimension of an object
 
Object name itself on command line or \code{(show(object))} will display 
class and dimensionality
}
\examples{
s <- scNMFSet(matrix(rpois(n=12,lambda=3),4,3))
show(s)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils2.R
\name{write_meta}
\alias{write_meta}
\title{Write meta genes to a file}
\usage{
write_meta(meta, file)
}
\arguments{
\item{meta}{List of meta genes output from \code{meta_genes}}

\item{file}{Output file name}
}
\value{
\code{NULL}
}
\description{
Write a csv file of meta gene lists from input list
}
\examples{
set.seed(1)
x <- simulate_whx(nrow=50, ncol=100, rank=5)
s <- scNMFSet(x$x)
s <- vb_factorize(s, ranks=seq(2,8), nrun=5)
plot(s)
m <- meta_genes(s, rank=5)
write_meta(m, file='meta.csv')
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/factorize.R
\name{factorize}
\alias{factorize}
\title{Maximum likelihood factorization}
\usage{
factorize(object, ranks = 2, nrun = 20, randomize = FALSE,
  nsmpl = 1, verbose = 2, progress.bar = TRUE, Itmax = 10000,
  ncnn.step = 40, criterion = "likelihood", linkage = "average",
  Tol = 1e-05, store.connectivity = FALSE)
}
\arguments{
\item{object}{\code{scNMFSet} object containing count matrix.}

\item{ranks}{Rank for factorization; can be a vector of multiple values.}

\item{nrun}{No. of runs with different initial guess.}

\item{randomize}{Boolean; if \code{TRUE}, input matrix is randomized.}

\item{nsmpl}{No. of randomized samples to average over.}

\item{verbose}{The verbosity level: 
3, each iteration output printed;
2, each run output printed; 
1, each randomized sample output printed;
0, silent.}

\item{progress.bar}{Display progress bar when \code{nrun > 1 } and 
\code{verbose = 1}.}

\item{Itmax}{Maximum no. of iteration.}

\item{ncnn.step}{Minimum no. of steps with no change in connectivity matrix 
to achieve convergence.}

\item{criterion}{If \code{'likelihood'}, iteration stops when fractional 
changes in likelihood is below tolerance \code{Tol}. If 
\code{criterion = 'connectivity'}, iteration stops when connectivity 
matrix does not change for at least \code{ncnn.step} steps.}

\item{linkage}{Method to be sent to \code{hclust} in 
calculating cophenetic correlation.}

\item{Tol}{Tolerance for checking convergence with 
\code{criterion = 'likelihood'}.}

\item{store.connectivity}{Returns a list also containing connectivity data.}
}
\value{
Object of class \code{scNMFSet} with factorization slots filled.
}
\description{
Performs single or multiple rank NMF factorization of count matrix using 
maximum likelihood
}
\details{
The main input is the \code{scNMFSet} object with count matrix.
This function performs non-negative factorization and fills in the empty
slots \code{basis}, \code{coeff}, and \code{ranks}.

When run with multiple values of \code{ranks}, 
        factorization is repeated for each rank and the slot \code{measure} 
        contains quality measures of the ranks. The quality measure 
        \code{likelihood} is negative the KL distance of the fit to the 
        target. With \code{nrun > 1}, the likelihood is the maximum 
        among all runs. 
        
        The quality measure \code{dispersion} is the scalar
        measure of how far the connectivity matrix is from 0, 1. With 
        increasing \code{nrun}, \code{dispersion} decreases from 1. 
        \code{nrun} should be chosen such that \code{dispersion} does not 
        change appreciably.
        With randomization, \code{count} matrix of \code{object} 
        is shuffled. 
        \code{nsmpl} can be used to average over multiple permutations. This 
        averaging applies to each quality measure under a given rank.
}
\examples{
set.seed(1)
x <- simulate_data(nfeatures=10,nsamples=c(20,20,60,40,30))
s <- scNMFSet(count=x)
s <- factorize(s,ranks=seq(2,8),nrun=5)
plot(s)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\docType{methods}
\name{dbasis<-,scNMFSet-method}
\alias{dbasis<-,scNMFSet-method}
\title{Modify dbasis matrices}
\usage{
\S4method{dbasis}{scNMFSet}(object) <- value
}
\arguments{
\item{object}{Object of class \code{scNMFSet}}

\item{value}{Basis SD matrix to be substituted}
}
\value{
Modified object
}
\description{
Access and modify dbasis matrices
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\name{dcoeff<-}
\alias{dcoeff<-}
\title{Coeff SD matrix assignment}
\usage{
dcoeff(object) <- value
}
\arguments{
\item{object}{Object containing dcoeff matrix}

\item{value}{List for assignment}
}
\value{
Updated object
}
\description{
Coeff SD matrix assignment
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\docType{class}
\name{scNMFSet-class}
\alias{scNMFSet-class}
\alias{plot,scNMFSet,ANY-method}
\title{Class \code{scNMFSet} for storing input data and results}
\usage{
\S4method{plot}{scNMFSet,ANY}(x)
}
\arguments{
\item{x}{Object containing measure}
}
\value{
Object of class \code{scNMFSet}

\code{NULL}
}
\description{
\code{S4} class derived from \code{\link{SingleCellExperiment}}
that can store single-cell count matrix, gene and cell annotation 
data frames, and factorization factors as well as quality measures 
for rank determination.
}
\section{Methods (by generic)}{
\itemize{
\item \code{plot}: Plot measures of an object. 
For quality measures derived from maximum likelihood inference, 
dispersion and cophenetic will be plotted separately.

For measure derived from Bayesian inference, log evidence as a function of 
rank values will be plotted.
}}

\section{Slots}{

\describe{
\item{\code{assays}}{Named list for count matrix \code{counts}.}

\item{\code{rowData}}{\code{DataFrame} for gene (feature) 
names and annotations in columns.}

\item{\code{colData}}{\code{DataFrame} for cell IDs and other 
annotations in columns (e.g., barcodes, cell types).}

\item{\code{ranks}}{Vector for rank values for which factorization has been 
performed.}

\item{\code{basis}}{List (of length equal to that of \code{ranks}) of 
basis matrices \strong{W} from factorization; 
dimension \code{nrow} x \code{rank},
    where \code{nrow} is no. of rows in \code{count}.}

\item{\code{coeff}}{List (of length equal to that of \code{ranks}) of 
coefficient matrices \strong{H} from factorization; 
     dimension \code{rank} x \code{ncol},
     where \code{ncol} is no. of columns in \code{count}.}

\item{\code{measure}}{Data frame of factorization quality measures for 
  each rank (\code{likelihood} and \code{dispersion}).

Other slots inherited from \code{SingleCellExperiment} class are 
not explicitly used.}
}}

\examples{
library(S4Vectors)
# toy matrix
ngenes <- 8 
ncells <- 5
mat <- matrix(rpois(n=ngenes*ncells,lambda=3),ngenes,ncells)

abc <- letters[seq_len(ngenes)]
ABC <- LETTERS[seq_len(ncells)] 
genes <- DataFrame(gene_id=abc)
cells <- DataFrame(cell_id=ABC)
rownames(mat) <- rownames(genes) <- abc
colnames(mat) <- rownames(cells) <- ABC

# create scNMFSet object
s <- scNMFSet(count=mat,rowData=genes,colData=cells)
# alternative ways
s2 <- scNMFSet(count=mat)
s2 <- scNMFSet(assays=list(counts=mat))        

# show dimensions
dim(s)

# show slots
rowData(s)

# modify slots
colData(s) <- DataFrame(cell_id=seq_len(ncells),
              cell_type=c(rep('tissue1',2),
                          rep('tissue2',ncells-2)))
colData(s)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\docType{methods}
\name{basis,scNMFSet-method}
\alias{basis,scNMFSet-method}
\title{Basis matrix accessor}
\usage{
\S4method{basis}{scNMFSet}(object)
}
\arguments{
\item{object}{Object containing basis matrix}
}
\value{
List of basis matrices
}
\description{
Basis matrix accessor
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\name{basis}
\alias{basis}
\title{Basis matrices in an Object}
\usage{
basis(object)
}
\arguments{
\item{object}{Object of class \code{scNMFSet}}
}
\value{
Either \code{NULL} or a list of same length as 
\code{ranks(object)}, whose
elements are basis matrices derived from factorization 
under each rank value.
}
\description{
Retrieve or set the basis matrices \code{W} from factorization 
in an object
}
\details{
After factorization, basis matrices corresponding to each rank value are
stored as elements of a list, which is in slot \code{basis} of object of
class \code{scNMFSet}.
\code{basis(object)} will return the list of matrices. 
\code{basis(object) <- value}
can be used to modify it.
}
\examples{
s <- scNMFSet(count=matrix(rpois(n=12,lambda=3),4,3))
s <- vb_factorize(s,ranks=seq(2,4))
basis(s)[[1]]
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scNMF_class.R
\docType{methods}
\name{counts,scNMFSet-method}
\alias{counts,scNMFSet-method}
\title{Accessor for count matrix}
\usage{
\S4method{counts}{scNMFSet}(object)
}
\arguments{
\item{object}{Object containing count matrix}
}
\value{
Count matrix
}
\description{
Accessor for count matrix
}
\examples{
s <- scNMFSet(count = matrix(rpois(n=12,lambda=3),3,4))
counts(s)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tree.R
\name{rename_tips}
\alias{rename_tips}
\title{Rename tips of trees with cell types}
\usage{
rename_tips(tree, rank, tip.labels)
}
\arguments{
\item{tree}{List containing tree}

\item{rank}{Rank value of which tip names are to be replaced}

\item{tip.labels}{Vector of new names for tips}
}
\value{
List containing tree with updated tip labels
}
\description{
Rename tips of trees with cell types
}
\examples{
set.seed(1)
x <- simulate_whx(nrow=50,ncol=100,rank=5)
s <- scNMFSet(x$x)
s <- vb_factorize(s,ranks=seq(2,8),nrun=5)
tree <- build_tree(s,rmax=5)
tree <- rename_tips(tree,rank=5,tip.labels=letters[seq_len(5)])
tree 
}
